<?php

/* rev 0.1 Feb,20 2008 [jcmichot] 
 * rev 0.2 Feb,17 2010 [jcmichot] add SOAP error handler, transfer .fr, various check
 * rev 0.3 Mar,29 2011 [jcmichot] add .re, add new tld for transfer, fix phone syntax with .fr, whmcs44x
 * rev 0.4 Mar,16 2012 [jcmichot] add .tv .cc .xxx .wf .tf .pm .yt (ouverture a l'europe des TLDs de l'AFNIC)
 * rev 0.5 Apr,21 2012 [jcmichot] fix pays_id pb
 * rev 0.6 Oct,9  2017 [jcmichot] fix php7 + whmcs7
 * rev 0.7 Oct,17 2017 [jcmichot] add DeleteDomain,TransferSync,GetEPPCode and Sync (status,date), upto 13 NS, TransOut/Reject/Approve
 * rev 0.8 May,29 2018 [jcmichot] whmcs7.5, EU RGPD, revision domain_transfer, add RestoreDomain
 * rev 0.81 Jan,20 2019 [jcmichot] fix for php7.2
 */

if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}

use WHMCS\Domains\DomainLookup\ResultsList;
use WHMCS\Domains\DomainLookup\SearchResult;
use WHMCS\Module\Registrar\Registrarmodule\ApiClient;

function web_email_debug( $data, $trace=0 )
{
	// debug is finish
	//return;

    // Reporte toutes les erreurs PHP (Voir l'historique des modifications)
    //error_reporting(E_ALL);

    ob_start();
    printf("\n\nDATA[]\n"); print_r( $data );

    if ( $trace ) {
        printf("\nBACKTRACE:\n");
        debug_print_backtrace();
        $dfunc = get_defined_functions();
        printf("\n\nget_defined_functions();\n"); print_r( $dfunc );
        printf("\n\n_GLOBALS[]\n"); print_r( $GLOBALS );
        printf("\n\n_SESSION[]\n"); print_r( $_SESSION );
        }
    $message = ob_get_contents();
    ob_end_clean();

    $sendmail = "/usr/sbin/sendmail -t -f poubelle@bookmyname.com api-domains+whmcsdebug@bookmyname.com";

    if ( ($fd = popen($sendmail, "w")) != FALSE ) {
    	fputs( $fd, "From: DEBUG WHMCS <poubelle@bookmyname.com>\n".
        "To: api-domains+debug@bookmyname.com\n".
        "Subject: [WHM] DEBUG API BookMyNAme\n".
        "MIME-Version: 1.0\n".
        "Content-Type: text/plain; charset=\"ISO-8859-1\"".
        "Content-Transfer-Encoding: 8BIT\n".
        "Content-Disposition: inline\n\n".
	"\n\nmessage =>\nDate:".date('r').
        "\nRemote_addr:".$_SERVER['REMOTE_ADDR'].
        "\n\n" );

        fputs($fd,  $message );
        pclose($fd);
        }

    return ;

    echo "<PRE>debug:";
    print_r( $data );
    echo "</PRE>\n";

}

function bookmyname_MetaData()
{
    return array(
        'DisplayName' => 'Sample Registrar Module for WHMCS',
        'APIVersion' => '1.1',
    );
}

function bookmyname_getConfigArray() {

	$configarray = array(

	"Username" => array( "Type" => "text", "Size" => "20", "Description" => "Enter your BookMyName ID number", ),
	"Password" => array( "Type" => "password", "Size" => "20", "Description" => "Enter your BookMyName Password ", ),
	"TestMode" => array( "Type" => "yesno", "Description" => "if you check this box, you are using OT&E Registrar and Registry plateform (OT&E=Operational Test and Evaluation)",  ),
	"ImportPriceMax"    => array( "Type" => "text", "Size" => "20", "Default"=>"300", "Description" => "(for Import) Max domain sell price", ),
	"ImportPriceFactor" => array( "Type" => "text", "Size" => "20", "Default"=>"1.5", "Description" => "(for Import) Registrar price mutiply factor (buy N, sell N*ImportPriceFactor)", ),
	"ImportMaxYear"     => array( "Type" => "text", "Size" => "20", "Default"=>"10", "Description" => "(for Import) Limit TLDs price import for max year (multi-year support)", ),
	"ForceUpdatePrice"  => array( "Type" => "yesno", "Default"=>"", "Description" => "(for Import) <b>WARNING</b> if you check this box, all previously defined prices will be removed", ),
	"DNSManagement"    => array( "Type" => "yesno", "Default"=>"checked", "Description" => "(for Import) if this box is checked, DNS Management service is activate for TLDs import", ),
    "EmailForwarding"  => array( "Type" => "yesno", "Default"=>"checked", "Description" => "(for Import) if this box is checked, Email Forwarding service is activate for TLDs import", ),
    "IDProtection"     => array( "Type" => "yesno", "Default"=>"checked", "Description" => "(for Import) if this box is checked, ID Protection service is activate for TLDs import", ),
	);

	return $configarray;
}

/*

function bookmyname_push($params) {

    // Only for .UK
    $domainid = $params['domainid'];
    $sld = $params['sld'];
    $tld = $params['tld'];

    return array(
        'templatefile' => 'pushdomain',
        'breadcrumb' => array(
            'clientarea.php?action=domaindetails&domainid='.$domainid.'&modop=custom&a=push' => 'Push Domain',
        ),
        'vars' => array(
            'var1' => 'valuehere',
            'var2' => 'anothervaluehere',
        ),
    );
}

function bookmyname_ClientAreaCustomButtonArray() {
    return array(
        "Push Domain" => "push",
    );
}

function bookmyname_AdminAreaCustomButtonArray() {
    return array(
        "Push Domain" => "push",
    );
}

function registrarmodule_ModifyNameserver($params) {
}
function registrarmodule_RegisterNameserver($params) {
}
function registrarmodule_DeleteNameserver($params) {
}
// * Used to initiate a transfer out such as an IPSTAG change for .UK domain names.
function registrarmodule_ReleaseDomain($params) {
}

*/

function bookmyname_AdminCustomButtonArray()
{

    $buttonArray = array(
        "Restore"             => "RestoreDomain",
        "TransferOut Approve" => "transferOutApprove",
        "TransferOut Reject"  => "transferOutReject",
        "BookMyName TLDs import"     => "importBMNtlds",
    );
    return $buttonArray;
}

function bookmyname_importBMNtlds( $params )
{
    global $db_host,$db_username,$db_password,$db_name;

    /* tld ( min, max ) = year avaiable to renew */
    $maxybytld = array(
    'at' => array( 1, 1 ),
    'be' => array( 1, 1 ),
    'ch' => array( 1, 1 ),
    'co' => array( 1, 5 ),
    'de' => array( 1, 1 ),
    'es' => array( 1, 5 ),
    'fm' => array( 1, 5 ),
    'io' => array( 1, 2 ), // 1,2,5
    'im' => array( 1, 1 ),
    'it' => array( 1, 1 ),
    'jp' => array( 1, 2 ), // 1,2,5
    'li' => array( 1, 1 ),
    'lu' => array( 1, 1 ),
    'mu' => array( 1, 5 ),
    'mx' => array( 1, 5 ),
    'nl' => array( 1, 1 ),
    'ws' => array( 1, 1 ),
    'tm' => array( 10,10 ),
    // no risk with high price tld
    'security' => array( 1,1 ),
    'protection' => array( 1,1 ),
    'theatre' => array( 1,2 ),
    'tickets' => array( 1,2 ),
    'game' => array( 1,2 ),
    'juegos' => array( 1,2 ),
    );

    // mutiply registrar cost by factor.
    if ( $params['ImportPriceFactor'] < 1 || $params['ImportPriceFactor'] > 10 )
        $prix_coefm = 1.5;
    else
        $prix_coefm = $params['ImportPriceFactor'];

    // do not sell product too expensive.
    if ( $params['ImportPriceMax'] < 100 || $params['ImportPriceMax'] > 1000 ) 
        $max_price = 300.00;
    else
        $max_price = $params['ImportPriceMax'];

    if ( $params['ImportMaxYear'] < 1 || $params['ImportMaxYear'] > 10 )
        $max_year = 10;
    else
        $max_year = $params['ImportMaxYear'];

    $forceupdate = $params['ForceUpdatePrice'];
    if ( 'on' == $forceupdate ) $forceupdate = 1; else $forceupdate = 0;

    $dnsmanagement = $params['DNSManagement'];
    $emailforwarding = $params['EmailForwarding'];
    $idprotection = $params['IDProtection'];

    include_once ("../../../configuration.php");

    $conf = array();
    $conf['host']          = $db_host;
    $conf['user']          = $db_username;
    $conf['passwd']        = $db_password;
    $conf['database']      = $db_name;
    $whmcsmysql            = "";

    //web_email_debug( array('conf'=>$conf, 'params'=>$params), 0 );

    $i = 0;
    $whmcsmysql=FALSE;
    while ( $i<10 && $whmcsmysql==FALSE ) {
        $whmcsmysql = mysqli_connect( $conf['host'], $conf['user'], $conf['passwd'], $conf['database'] );
        if ( $whmcsmysql==FALSE && $i>5 ) 
            return( array( 'error' => 'Retry #5 : Could not connect to SQL server') );
        $i++;
        sleep ( 1 );
        }

    $inc=1;
    $query = 'SELECT max(`order`) as maxorderval FROM tbldomainpricing';
    $res = $whmcsmysql->query( $query );
    if ( $res->num_rows )
         while ($row = mysqli_fetch_array($res)) 
            $inc = $row['maxorderval'];

    $url = 'http://api.bookmyname.com/apis.cgi';
    $client = new SoapClient( NULL, array(  'location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );
 
    // priceslist are public no login/passwd needed
    $result = $client->api_priceslist();
    if ( $result['retcode'] != 1 )
        return( array( 'error' => "Fatal Error: SOAP request api_priceslist() failed !\n") );

    ob_start(); 
    echo "<PRE>"; 
    printf("TLDs to import: %d\n", $result['retval'] );
    foreach( $result['retfields'] as $tld => $val ) {
        if ( !isset( $val['Create'][1] ) ) $val['Create'][1] = -100;
        if ( !isset( $val['Renew'][1] ) )  $val['Renew'][1] = -100;
        if ( !isset( $val['Transfer'][1] ) ) $val['Transfer'][1] = -100;
        if ( !isset( $val['Restore'][1] ) ) $val['Restore'][1] = -100;
        if ( !isset( $val['ChangeOwner'][1] ) ) $val['ChangeOwner'][1] = -100;

        $modeupdate = 0;
        $query = sprintf( "SELECT * FROM tbldomainpricing WHERE autoreg='bookmyname' AND extension='.%s'", strtolower($tld) );
        $res = $whmcsmysql->query( $query );
        if ( $res->num_rows )
            while ($row = mysqli_fetch_array($res)) {
                $modeupdate=1;
                $tbldomainpricing_id = $row['id'];
                }

        if ( 0 == $modeupdate ) {
            $inc++;
            $query = sprintf("INSERT INTO tbldomainpricing SET extension='.%s',dnsmanagement='%s',emailforwarding='%s',idprotection='%s',eppcode='on',autoreg='bookmyname',`group`='',`order`=%d", 
                strtolower($tld), $dnsmanagement, $emailforwarding, $idprotection, $inc );
            $res = $whmcsmysql->query( $query );
            $tbldomainpricing_id = mysqli_insert_id($whmcsmysql);
            }
        else
        if ( $forceupdate ) {
            $query = sprintf("UPDATE tbldomainpricing SET dnsmanagement='%s',emailforwarding='%s',idprotection='%s',eppcode='on',autoreg='bookmyname' WHERE extension='.%s' AND id=%d", 
                $dnsmanagement, $emailforwarding, $idprotection, strtolower($tld), $tbldomainpricing_id );
            $res = $whmcsmysql->query( $query );
            }

        if ( 0 == $modeupdate || 0 != $forceupdate ) {
            printf("BMN <b>%s</b> buying price '%s' create %.2f&euro; renew %.2f&euro; transfer %.2f&euro; %s)\n",
                $tld,
                $val['Create'][1]/100,
                $val['Renew'][1]/100,
                $val['Transfer'][1]/100,
                //$val['Restore'][1]/100, $val['ChangeOwner'][1]/100,
                (1==$forceupdate) ? "WARNING: forceupdate":""
                );
            }

        $tld_min_year = 1;
        $tld_max_year = $max_year; /* from config */
        if ( isset( $maxybytld[ $tld ] ) ) { /* from registry */
            list( $tld_min_year, $tld_max_year ) = $maxybytld[ $tld ];
            if ( $tld_max_year > $max_year ) $tld_max_year = $max_year;
            }

        // In case of end of Promotion => do not sell lower than buying price
        $promoforceupdate_register = 0;
        $promoforceupdate_renew = 0;
        $promoforceupdate_transfer = 0;

        // Create / price setup
        $pc1a = $pc2a = $pc3a = $pc4a = $pc5a = $pc6a = $pc7a = $pc8a = $pc9a = $pc10a = -1.00;
        if ( $val['Create'][1] > 0 ) {
            $pc1a = $prix_coefm * 1 * $val['Create'][1]/100;
            $pc2a = $prix_coefm * 2 * $val['Create'][1]/100;
            $pc3a = $prix_coefm * 3 * $val['Create'][1]/100;
            $pc4a = $prix_coefm * 4 * $val['Create'][1]/100;
            $pc5a = $prix_coefm * 5 * $val['Create'][1]/100;
            $pc6a = $prix_coefm * 6 * $val['Create'][1]/100;
            $pc7a = $prix_coefm * 7 * $val['Create'][1]/100;
            $pc8a = $prix_coefm * 8 * $val['Create'][1]/100;
            $pc9a = $prix_coefm * 9 * $val['Create'][1]/100;
            $pc10a = $prix_coefm * 10 * $val['Create'][1]/100;
            if ( $pc1a > $max_price  || $tld_min_year > 1 ) $pc1a = -1.00;
            if ( $pc2a > $max_price  || $tld_min_year > 2  || $tld_max_year < 2 ) $pc2a = -1.00;
            if ( $pc3a > $max_price  || $tld_min_year > 3  || $tld_max_year < 3 ) $pc3a = -1.00;
            if ( $pc4a > $max_price  || $tld_min_year > 4  || $tld_max_year < 4 ) $pc4a = -1.00;
            if ( $pc5a > $max_price  || $tld_min_year > 5  || $tld_max_year < 5 ) $pc5a = -1.00;
            if ( $pc6a > $max_price  || $tld_min_year > 6  || $tld_max_year < 6 ) $pc6a = -1.00;
            if ( $pc7a > $max_price  || $tld_min_year > 7  || $tld_max_year < 7 ) $pc7a = -1.00;
            if ( $pc8a > $max_price  || $tld_min_year > 8  || $tld_max_year < 8 ) $pc8a = -1.00;
            if ( $pc9a > $max_price  || $tld_min_year > 9  || $tld_max_year < 9 ) $pc9a = -1.00;
            if ( $pc10a > $max_price || $tld_min_year > 10 || $tld_max_year < 10 ) $pc10a = -1.00;
            }

        // Renew / price setup
        $pr1a = $pr2a = $pr3a = $pr4a = $pr5a = $pr6a = $pr7a = $pr8a = $pr9a = $pr10a = -1.00;
        if ( $val['Renew'][1] > 0 ) {
            $pr1a = $prix_coefm * 1 * $val['Renew'][1]/100;
            $pr2a = $prix_coefm * 2 * $val['Renew'][1]/100;
            $pr3a = $prix_coefm * 3 * $val['Renew'][1]/100;
            $pr4a = $prix_coefm * 4 * $val['Renew'][1]/100;
            $pr5a = $prix_coefm * 5 * $val['Renew'][1]/100;
            $pr6a = $prix_coefm * 6 * $val['Renew'][1]/100;
            $pr7a = $prix_coefm * 7 * $val['Renew'][1]/100;
            $pr8a = $prix_coefm * 8 * $val['Renew'][1]/100;
            $pr9a = $prix_coefm * 9 * $val['Renew'][1]/100;
            $pr10a = $prix_coefm * 10 * $val['Renew'][1]/100;
            if ( $pr1a > $max_price  || $tld_min_year > 1  || $tld_max_year < 1 ) $pr1a = -1.00;
            if ( $pr2a > $max_price  || $tld_min_year > 2  || $tld_max_year < 2 ) $pr2a = -1.00;
            if ( $pr3a > $max_price  || $tld_min_year > 3  || $tld_max_year < 3 ) $pr3a = -1.00;
            if ( $pr4a > $max_price  || $tld_min_year > 4  || $tld_max_year < 4 ) $pr4a = -1.00;
            if ( $pr5a > $max_price  || $tld_min_year > 5  || $tld_max_year < 5 ) $pr5a = -1.00;
            if ( $pr6a > $max_price  || $tld_min_year > 6  || $tld_max_year < 6 ) $pr6a = -1.00;
            if ( $pr7a > $max_price  || $tld_min_year > 7  || $tld_max_year < 7 ) $pr7a = -1.00;
            if ( $pr8a > $max_price  || $tld_min_year > 8  || $tld_max_year < 8 ) $pr8a = -1.00;
            if ( $pr9a > $max_price  || $tld_min_year > 9  || $tld_max_year < 9 ) $pr9a = -1.00;
            if ( $pr10a > $max_price || $tld_min_year > 10 || $tld_max_year < 10 ) $pr10a = -1.00;
            }

        // Transfer / price setup
        $pt1a = $prix_coefm * 1 * $val['Transfer'][1]/100;
        if ( $pt1a > $max_price ) $pt1a = -1.00;

        $modeupdate = 0;
        $query = sprintf( "SELECT * FROM tblpricing WHERE relid=%d AND type='domainregister' AND currency=1", $tbldomainpricing_id );
        $res = $whmcsmysql->query( $query );
        if ( $res->num_rows )
            while ($row = mysqli_fetch_array($res)) {
                $modeupdate=1;
                if ( $row['msetupfee'] != -1 &&  $row['msetupfee'] < ($val['Create'][1]/100) )
                    $promoforceupdate_register = 1;
                }

        if ( 0 == $modeupdate ) {
           $query = sprintf("INSERT INTO tblpricing SET type='domainregister',relid=%d,currency=1,".
                "msetupfee=%.2f,qsetupfee=%.2f,ssetupfee=%.2f,asetupfee=%.2f,bsetupfee=%.2f,".
                "tsetupfee=0.00,monthly=%.2f,quarterly=%.2f,semiannually=%.2f,annually=%.2f,".
                "biennially=%.2f,triennially=0.00", 
                $tbldomainpricing_id,
                $pc1a,$pc2a,$pc3a,$pc4a,$pc5a,$pc6a,$pc7a,$pc8a,$pc9a,$pc10a
                );
            //printf("QUERY: %s\n", $query );
            printf("<b>.%s</b> add register price\n", $tld);
            $res = $whmcsmysql->query( $query );
            }

        $modeupdate = 0;
        $query = sprintf( "SELECT * FROM tblpricing WHERE relid=%d AND type='domainrenew' AND currency=1", $tbldomainpricing_id );
        $res = $whmcsmysql->query( $query );
        if ( $res->num_rows )
            while ($row = mysqli_fetch_array($res)) {
                $modeupdate=1;
                if ( $row['msetupfee'] != -1 &&  $row['msetupfee'] < ($val['Renew'][1]/100) )
                    $promoforceupdate_renew = 1;
                }
        if ( 0 == $modeupdate ) {
           $query = sprintf("INSERT INTO tblpricing SET type='domainrenew',relid=%d,currency=1,".
                "msetupfee=%.2f,qsetupfee=%.2f,ssetupfee=%.2f,asetupfee=%.2f,bsetupfee=%.2f,".
                "tsetupfee=0.00,monthly=%.2f,quarterly=%.2f,semiannually=%.2f,annually=%.2f,".
                "biennially=%.2f,triennially=0.00", 
                $tbldomainpricing_id,
                $pr1a,$pr2a,$pr3a,$pr4a,$pr5a,$pr6a,$pr7a,$pr8a,$pr9a,$pr10a
                );
            //printf("QUERY: %s\n", $query );
            printf("<b>.%s</b> add renew price\n", $tld);
            $res = $whmcsmysql->query( $query );
            }

        $modeupdate = 0;
        $query = sprintf( "SELECT * FROM tblpricing WHERE relid=%d AND type='domaintransfer' AND currency=1", $tbldomainpricing_id );
        $res = $whmcsmysql->query( $query );
        if ( $res->num_rows )
            while ($row = mysqli_fetch_array($res)) {
                $modeupdate=1;
                if ( $row['msetupfee'] != -1 &&  $row['msetupfee'] < ($val['Transfer'][1]/100) )
                    $promoforceupdate_transfer = 1;
                }
         if ( 0 == $modeupdate && $val['Transfer'][1] > 0 ) {
               $query = sprintf("INSERT INTO tblpricing SET type='domaintransfer',relid=%d,currency=1,".
                    "msetupfee=%.2f,qsetupfee=%.2f,ssetupfee=%.2f,asetupfee=%.2f,bsetupfee=%.2f,".
                    "tsetupfee=0.00,monthly=%.2f,quarterly=%.2f,semiannually=%.2f,annually=%.2f,".
                    "biennially=%.2f,triennially=0.00", 
                    $tbldomainpricing_id,
                    $pt1a,
                    -1,-1,-1,-1,-1,-1,-1,-1,-1
                    );
                //printf("QUERY: %s\n", $query );
                printf("<b>.%s</b> add transfer price\n", $tld);
                $res = $whmcsmysql->query( $query );
                }

        // FORCE UPDATE PRICE || end of promo
        if ( $forceupdate || $promoforceupdate_register ) {
            $query = sprintf("UPDATE tblpricing SET ".
                "msetupfee=%.2f,qsetupfee=%.2f,ssetupfee=%.2f,asetupfee=%.2f,bsetupfee=%.2f,".
                "tsetupfee=0.00,monthly=%.2f,quarterly=%.2f,semiannually=%.2f,annually=%.2f,".
                "biennially=%.2f,triennially=0.00 WHERE relid=%d AND type='domainregister' AND currency=1", 
                $pc1a,$pc2a,$pc3a,$pc4a,$pc5a,$pc6a,$pc7a,$pc8a,$pc9a,$pc10a,
                $tbldomainpricing_id
                );
            //printf("QUERY: %s\n", $query );
            printf("<b>.%s</b> update register price\n", $tld);
            $res = $whmcsmysql->query( $query );
            }

        // FORCE UPDATE PRICE || end of promo
        if ( $forceupdate || $promoforceupdate_renew ) {
            $query = sprintf("UPDATE tblpricing SET ".
                "msetupfee=%.2f,qsetupfee=%.2f,ssetupfee=%.2f,asetupfee=%.2f,bsetupfee=%.2f,".
                "tsetupfee=0.00,monthly=%.2f,quarterly=%.2f,semiannually=%.2f,annually=%.2f,".
                "biennially=%.2f,triennially=0.00 WHERE relid=%d AND type='domainrenew' AND currency=1", 
                $pr1a,$pr2a,$pr3a,$pr4a,$pr5a,$pr6a,$pr7a,$pr8a,$pr9a,$pr10a,
                $tbldomainpricing_id
                );
            //printf("QUERY: %s\n", $query );
            printf("<b>.%s</b> update renew price\n", $tld);
            $res = $whmcsmysql->query( $query );
            }

        // FORCE UPDATE PRICE || end of promo
        if ( $forceupdate || $promoforceupdate_transfer ) {
            if ( $val['Transfer'][1] > 0 ) {
                $query = sprintf("UPDATE tblpricing SET ".
                    "msetupfee=%.2f,qsetupfee=%.2f,ssetupfee=%.2f,asetupfee=%.2f,bsetupfee=%.2f,".
                    "tsetupfee=0.00,monthly=%.2f,quarterly=%.2f,semiannually=%.2f,annually=%.2f,".
                    "biennially=%.2f,triennially=0.00 WHERE relid=%d AND type='domaintransfer' AND currency=1", 
                    $pt1a,
                    -1,-1,-1,-1,-1,-1,-1,-1,-1,
                    $tbldomainpricing_id
                    );
               // printf("QUERY: %s\n", $query );
                printf("<b>.%s</b> update transfer price\n", $tld);
                $res = $whmcsmysql->query( $query );
                }
            }
   
        }

    echo "</PRE>"; 
    $message .= ob_get_contents();
    ob_end_clean();

    printf("<B>BookMyName Registrar import TLDs and prices</B><br><br>\n");
    echo $message;

    return( array('success' => 'success' ) );
}

function bookmyname_transferOutApprove( $params )
{
	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$domain = $params["sld"].".".$params["tld"];
	$values["error"] = "";

	//web_email_debug( $params );

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

	try {
    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new soapclient( null, array('location' => $url, 'uri' => $url, 'encoding'=>'utf-8') );
  	$result = $client->domain_info( $username, $password, $domain );
	}
	catch (soapfault $fault) { return( array('error' => "soap error handler transferOutNAck / domain_info()" ) ); }

	if ( $result['retcode'] != 1 ) {
		$values["error"] = "domain_info failed ".$domain."\n<br>";
		ob_start(); echo "<PRE>"; print_r( $result ); echo "</PRE>"; $values["error"] .= ob_get_contents(); ob_end_clean();

        logModuleCall( "bookmyname", "transferOutApprove", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );
		return $values;
		}

    $authcode = '';
	if ( isset( $result['retfields']['authinfo'] ) )
	    $authcode = $result['retfields']['authinfo'];

	try { $result = $client->domain_transfer_out( $username, $password, $domain, $authcode, 'TransferApprove' ); }
	catch (soapfault $fault) { return( array('error' => "soap error handler transferOutApprove / domain_transfer_out()" ) ); }

    logModuleCall( "bookmyname", "transferOutApprove", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );

    if ( $result['retcode'] != 1 ) {
		$values["error"] = "domain_transfer_out(".$domain.",TransferApprove) failed";
        if ( $result['retval'] == -3 )  $values["error"] .= ", invalid authcode";
        if ( $result['retval'] == -4 )  $values["error"] .= ", invalid mode";
        if ( $result['retval'] == -5 )  $values["error"] .= ", NO TRANSOUT PENDING";
        if ( $result['retval'] == -6 )  $values["error"] .= ", access denied";
        if ( $result['retval'] == -7 )  $values["error"] .= ", ALLREADY PROCESSED" ;
        $values["error"] .= "<br>\n";
        return ( $values );
        }

	return $values;}

function bookmyname_transferOutReject( $params )
{
	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$domain = $params["sld"].".".$params["tld"];
	$values["error"] = "";

	//web_email_debug( $params );

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

	try {
    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new soapclient( null, array('location' => $url, 'uri' => $url, 'encoding'=>'utf-8') );
  	$result = $client->domain_info( $username, $password, $domain );
	}
	catch (soapfault $fault) { return( array('error' => "soap error handler transferOutReject / domain_info()" ) ); }

	if ( $result['retcode'] != 1 ) {
		$values["error"] = "domain_info failed ".$domain."\n<br>";
		ob_start(); echo "<PRE>"; print_r( $result ); echo "</PRE>"; $values["error"] .= ob_get_contents(); ob_end_clean();

        logModuleCall( "bookmyname", "transferOutReject", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );
		return $values;
		}

    $authcode = '';
	if ( isset( $result['retfields']['authinfo'] ) )
	    $authcode = $result['retfields']['authinfo'];

	try { $result = $client->domain_transfer_out( $username, $password, $domain, $authcode, 'TransferReject' ); }
	catch (soapfault $fault) { return( array('error' => "soap error handler transferOutReject / domain_transfer_out()" ) ); }

    logModuleCall( "bookmyname", "transferOutReject", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );

    if ( $result['retcode'] != 1 ) {
		$values["error"] = "domain_transfer_out(".$domain.",TransferReject) failed";
        if ( $result['retval'] == -3 )  $values["error"] .= ", invalid authcode";
        if ( $result['retval'] == -4 )  $values["error"] .= ", invalid mode";
        if ( $result['retval'] == -5 )  $values["error"] .= ", NO TRANSOUT PENDING";
        if ( $result['retval'] == -6 )  $values["error"] .= ", access denied";
        if ( $result['retval'] == -7 )  $values["error"] .= ", ALLREADY PROCESSED" ;
        $values["error"] .= "<br>\n";
        return ( $values );
        }

	return $values;
}

function bookmyname_CheckAvailability($params)
{
	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];

	$values["error"] = "";
    $atld = array();
    $stdls = "";

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    foreach( $params['tlds'] as $key => $tld )
        array_push( $atld, strtolower( substr($tld,1) ) );
    foreach( $params['tldsToInclude'] as $key => $tld ) 
        array_push( $atld, strtolower( substr($tld,1) ) );
    $atld = array_unique( $atld );
    if ( !count($atld) )
        $stlds = "suggest";
    else
        foreach( $atld as $tld )
            $stlds .= $tld.' ';

    $stlds = trim( $stlds );

    use_soap_error_handler(false);

	try {

    $url = "http://api.bookmyname.com/apis.cgi";
    if ( $testmode == "on" )
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

    $result = $client->domain_multicheck( $username, $password, $sld, $stlds );
	}
	catch (SoapFault $fault) {
        return( array('error' => "SOAP error handler CheckAvailability() / domain_multicheck()" ) );
	    }

    // no correct reply from SOAP API
    if ( $result['retcode'] != 1 )
        return( array( 'error' => 'no check' ) );

    $resultslist = new ResultsList();

    foreach( $result['retfields'] as $rtld => $available ) {

            // Instantiate a new domain search result object
            $searchResult = new SearchResult( $sld, '.'.$rtld );

            // Determine the appropriate status to return
            if ( 1 == $available ) 
                $status = SearchResult::STATUS_NOT_REGISTERED;
            else
                $status = SearchResult::STATUS_REGISTERED;

            $searchResult->setStatus($status);
            $searchResult->setPremiumDomain(false);

            // Append to the search results list
            $resultslist->append($searchResult);
        }

    //logModuleCall( "bookmyname", "CheckAvailability", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );

    return $resultslist;

}

function bookmyname_DomainSuggestionOptions() {

    return array(
        'includeCCTlds' => array(
            'FriendlyName' => 'Include Country Level TLDs',
            'Type' => 'yesno',
            'Description' => 'Tick to enable',
        ),
    );

/*
    return array(
        'includeCCTlds' => array(
            'FriendlyName' => 'The TLDs you select here will be checked for availability and displayed in addition to the users requested search term.<P>',
            'Type' => 'dropdown',
            'Options' => array(
                'tld1' => 'tld1 (great tld)',
                'tld2' => 'tld2 (alternative)',
                'tld3' => 'tld3 (another idea...)',
                ),
            'Description' => '<P>Use Ctrl+Click to select multiple options and/or de-select individual ones',
            )
        );
*/

}

function bookmyname_GetDomainSuggestions($params)
{
	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$sld = $params["searchTerm"];

	$values["error"] = "";
    $atld = array();
    $stdls = "";

	if ( $username == 0 || strlen($password) < 4 ) {
		$values["error"] = "Reseller login error";
		return ( $values );
		}

    foreach( $params['tlds'] as $key => $tld )
        array_push( $atld, strtolower( substr($tld,1) ) );
    // ??? il a tout les TLDs de la base SQL dans tldsToInclude....
    foreach( $params['tldsToInclude'] as $key => $tld ) 
        array_push( $atld, strtolower( substr($tld,1) ) );
    $atld = array_unique( $atld );
    if ( !count($atld) || count($atld)>50 ) {
        $stlds = "suggest";
        }
    else
        foreach( $atld as $tld )
            $stlds .= $tld.' ';

    //web_email_debug( array( 'action'=>'GetDomainSuggestions', 'params'=>$params ) );

    $stlds = trim( $stlds );

    use_soap_error_handler(false);

	try {
    $url = "http://api.bookmyname.com/apis.cgi";
    if ( $testmode == "on" )
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

  	$result = $client->domain_multicheck( $username, $password, $sld, $stlds );
	} catch (SoapFault $fault) {
        return( array('error' => "SOAP error handler GetDomainSuggestions() / domain_multicheck()" ) );
    	}

    // no correct reply from SOAP API
    if ( $result['retcode'] != 1 )
        return( array( 'error' => 'no check' ) );


    $resultslist = new ResultsList();

    $score=1;
    foreach( $result['retfields'] as $rtld => $available ) {
            if ( 1 != $available ) continue; // only process available domain name

            // Instantiate a new domain search result object
            $searchResult = new SearchResult( $sld, '.'.$rtld );

            $status = SearchResult::STATUS_NOT_REGISTERED;

            $searchResult->setStatus($status);
            $searchResult->setPremiumDomain(false);
            $score++;
            $searchResult->setScore($score);

            // Append to the search results list
            $resultslist->append($searchResult);
        }

    //logModuleCall( "bookmyname", "GetDomainSuggestions", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );

    return $resultslist;
}


function bookmyname_api_info($params)
{
	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

    try {
    $url = "http://api.bookmyname.com/apis.cgi";
    if ( $testmode == "on" )
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

    $result = $client->api_info( $username, $password );
	} catch (SoapFault $fault) {
        return( array('error' => "SOAP error handler api_info()" ) );
        }

    // Error? 
    if ( $result['retcode'] != 1 ) return ( array() );

    return array( $result );
}

function bookmyname_api_pending($params)
{
	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

    try {
    $url = "http://api.bookmyname.com/apis.cgi";
    if ( $testmode == "on" )
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

    $result = $client->api_pending_status( $username, $password, 2 /*2mois*/ );
	}
    catch (SoapFault $fault) {
        return( array('error' => "SOAP error handler api_pending()" ) );
        }

    // Error? => No status change, return empty array
    if ( $result['retcode'] != 1 ) return ( array() );

    return array( 'pending' => $result['retfields'] );
}

function bookmyname_GetNameservers($params) {

	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$domain = $params["sld"].".".$params["tld"];
	$values["error"] = "";

	//web_email_debug( $params );

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

	try {
    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );
  	$result = $client->domain_info( $username, $password, $domain );
	}
	catch (SoapFault $fault) {
        return( array('error' => "SOAP error handler GetNameservers() / domain_info()" ) );
    	}

	if ( $result['retcode'] == 1 ) {
		if ( isset( $result['retfields']['ns0'] ) ) $values["ns1"] = $result['retfields']['ns0'];
		if ( isset( $result['retfields']['ns1'] ) ) $values["ns2"] = $result['retfields']['ns1'];
		if ( isset( $result['retfields']['ns2'] ) ) $values["ns3"] = $result['retfields']['ns2'];
		if ( isset( $result['retfields']['ns3'] ) ) $values["ns4"] = $result['retfields']['ns3'];
		if ( isset( $result['retfields']['ns4'] ) ) $values["ns5"] = $result['retfields']['ns4'];
		if ( isset( $result['retfields']['ns5'] ) ) $values["ns6"] = $result['retfields']['ns5'];
		if ( isset( $result['retfields']['ns6'] ) ) $values["ns7"] = $result['retfields']['ns6'];
		if ( isset( $result['retfields']['ns7'] ) ) $values["ns8"] = $result['retfields']['ns7'];
		if ( isset( $result['retfields']['ns8'] ) ) $values["ns9"] = $result['retfields']['ns8'];
		if ( isset( $result['retfields']['ns9'] ) ) $values["ns10"] = $result['retfields']['ns9'];
		if ( isset( $result['retfields']['ns10'] ) ) $values["ns11"] = $result['retfields']['ns10'];
		if ( isset( $result['retfields']['ns11'] ) ) $values["ns12"] = $result['retfields']['ns11'];
		if ( isset( $result['retfields']['ns12'] ) ) $values["ns13"] = $result['retfields']['ns12'];
		return ( $values );
		}
 
	return $values;
}

function bookmyname_SaveNameservers($params) {

	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$domain = $params["sld"].".".$params["tld"];
	$values["error"] = ""; //$error;

	//web_email_debug( $params );

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

	try {
    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );
   	$result = $client->domain_info( $username, $password, $domain );
	}
    catch (SoapFault $fault) {
            return( array('error' => "SOAP error handler SaveNameservers() / domain_info()" ) );
        }

	if ( $result['retcode'] != 1 ) {
		$values["error"] = "domain_info failed ".$domain."\n<br>";
		ob_start(); echo "<PRE>"; print_r( $result ); echo "</PRE>"; $values["error"] .= ob_get_contents(); ob_end_clean();
		return $values;
		}

	$udomain['domain'] = $domain;
	$udomain['owner_id'] = $result['retfields']['owner_id'];
	$udomain['admin_id'] = $result['retfields']['admin_id'];
	$udomain['tech_id'] = $result['retfields']['tech_id'];
	$udomain['bill_id'] = $result['retfields']['bill_id'];
	$udomain['service'] = "dns";
	if ( strlen(trim($params["ns1"])) ) $udomain['ns0'] = $params["ns1"];
	if ( strlen(trim($params["ns2"])) ) $udomain['ns1'] = $params["ns2"];
	if ( strlen(trim($params["ns3"])) ) $udomain['ns2'] = $params["ns3"];
	if ( strlen(trim($params["ns4"])) ) $udomain['ns3'] = $params["ns4"];
	if ( strlen(trim($params["ns5"])) ) $udomain['ns4'] = $params["ns5"];
	if ( strlen(trim($params["ns6"])) ) $udomain['ns5'] = $params["ns6"];
	if ( strlen(trim($params["ns7"])) ) $udomain['ns6'] = $params["ns7"];
	if ( strlen(trim($params["ns8"])) ) $udomain['ns7'] = $params["ns8"];
	if ( strlen(trim($params["ns9"])) ) $udomain['ns8'] = $params["ns9"];
	if ( strlen(trim($params["ns10"])) ) $udomain['ns9'] = $params["ns10"];
	if ( strlen(trim($params["ns11"])) ) $udomain['ns10'] = $params["ns11"];
	if ( strlen(trim($params["ns12"])) ) $udomain['ns11'] = $params["ns12"];

    try { $result = $client->domain_update( $username, $password, $domain, $udomain ); }
    catch (SoapFault $fault) { return( array('error' => "SOAP error handler SaveNameservers() / domain_update()" ) ); }

	if ( $result['retcode'] != 1 ) {
		$values["error"] = "domain_update error ".$domain."\n<br>";
		ob_start(); echo "<PRE>"; print_r( $result ); echo "</PRE>"; $values["error"] .= ob_get_contents(); ob_end_clean();

        logModuleCall( "bookmyname", "SaveNameservers", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );
		return $values;
		}

	return $values;
}

function bookmyname_GetRegistrarLock($params) {

	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$domain = $params["sld"].".".$params["tld"];
	$tld = $params["tld"];
	$sld = $params["sld"];

	$values["error"] = "";

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

	try {
    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

  	$result = $client->domain_info( $username, $password, $domain );
	} catch (SoapFault $fault) {
            return( array('error' => "SOAP error handler GetRegistrarLock() / domain_info()" ) );
        }

	/*
	registry_status 	001 	clientDeleteProhibited
	registry_status 	002 	serverDeleteProhibited
	registry_status 	004 	clientHold
	registry_status 	008 	serverHold
	registry_status 	010 	clientRenewProhibited
	registry_status 	020 	serverRenewProhibited
	registry_status 	040 	clientTransferProhibited
	registry_status 	080 	serverTransferProhibited
	registry_status 	0100 	clientUpdateProhibited
	registry_status 	0200 	serverUpdateProhibited
	registry_status 	0400 	pendingCreate
	registry_status 	0800 	pendingDelete
	registry_status 	01000 	pendingRenew
	registry_status 	02000 	pendingTransfer
	registry_status 	04000 	pendingUpdate
	*/

	$lockstatus="unlocked";

	if ( $result['retcode'] == 1 ) {

		$lockstatus="unlocked";

		$rstat = $result['retfields']['registry_status'];
		if ( $rstat & 0x01 ) $lockstatus="locked";
		if ( $rstat & 0x02 ) $lockstatus="locked";
		if ( $rstat & 0x04 ) $lockstatus="locked";
		if ( $rstat & 0x08 ) $lockstatus="locked";
		if ( $rstat & 0x10 ) $lockstatus="locked";
		if ( $rstat & 0x20 ) $lockstatus="locked";
		if ( $rstat & 0x40 ) $lockstatus="locked";
		if ( $rstat & 0x80 ) $lockstatus="locked";
		if ( $rstat & 0x100 ) $lockstatus="locked";
		if ( $rstat & 0x200 ) $lockstatus="locked";
	}

	return $lockstatus;
}

function bookmyname_SaveRegistrarLock($params) {

	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$domain = $params["sld"].".".$params["tld"];
	$tld = $params["tld"];
	$sld = $params["sld"];

	if ($params["lockenabled"] == "locked" )
		$lockstatus="locked";
	else
		$lockstatus="unlocked";

	$values["error"] = "";

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

    try {

    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

	$udomain['domain'] = $domain;
	if ( $lockstatus=="locked" )
		$udomain['registry_status'] = 64; // Transfer Prohibited
	else
		$udomain['registry_status'] = 0;  // Transfer Granted

	// update le authcode EPP
	$udomain['authinfo'] = mkpasswd( 12 );

   	$result = $client->domain_info( $username, $password, $domain );

	} catch (SoapFault $fault) {
        return( array('error' => "SOAP error handler SaveRegistrarLock() / domain_info()" ) );
        }

	if ( $result['retcode'] != 1 ) {
		$values["error"] = "domain_info failed ".$domain."\n<br>";
		ob_start(); echo "<PRE>"; print_r( $result ); echo "</PRE>"; $values["error"] .= ob_get_contents(); ob_end_clean();
		return $values;
		}

	$values['lockenabled'] = $lockstatus;
	// it's allready ok with request
	if ( $udomain['registry_status'] == $result['retfields']['registry_status'] )
		return $values;

	$udomain['owner_id'] = $result['retfields']['owner_id'];
	$udomain['admin_id'] = $result['retfields']['admin_id'];
	$udomain['tech_id'] = $result['retfields']['tech_id'];
	$udomain['bill_id'] = $result['retfields']['bill_id'];
	$udomain['service'] = $result['retfields']['service'];

    try { $result = $client->domain_update( $username, $password, $domain, $udomain ); }
    catch (SoapFault $fault) { return( array('error' => "SOAP error handler SaveRegistrarLock() / domain_update()" ) ); }

	if ( $result['retcode'] != 1 ) {
		$values["error"] = "domain_update error ".$domain."\n<br>";
		ob_start(); echo "<PRE>"; print_r( $result ); echo "</PRE>"; $values["error"] .= ob_get_contents(); ob_end_clean();
        logModuleCall( "bookmyname", "SaveRegistrarLock", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );
		return $values;
		}

	return $values;
}

function bookmyname_GetEmailForwarding($params) {

	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];

	$domain = $params["sld"].".".$params["tld"];

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

	try {
    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

  	$result = $client->service_redir_list( $username, $password, $domain, "mail" );
	} catch (SoapFault $fault) {
            return( array('error' => "SOAP error handler GetEmailForwarding() / service_redir_list()" ) );
        }

	if ( $result['retcode'] == -1 ) {
		$values["error"] = "service_redir_list error ".$domain."\n<br>";
		return( $values );
		}

	$counter = 0;
	foreach( $result['retfields'] as $key => $value ) {
		if ( $counter>=10 ) continue;

		$key = str_replace( "@".$domain, "", $key );
		$values[ $counter ]["prefix"] = $key;
		$values[ $counter ]["forwardto"] = $value;
		$counter++;
		}

	return $values;
}

function bookmyname_SaveEmailForwarding($params) {

	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];

	$values["error"] = "";

	$domain = $params["sld"].".".$params["tld"];

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

    try {
    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

	// delete all existing mail redirect
    $result = $client->service_redir_list( $username, $password, $domain, "mail" );

    } catch (SoapFault $fault) {
        return( array('error' => "SOAP error handler SaveEmailForwarding() / service_redir_list()" ) );
        }

	if ( $result['retcode'] == 1 ) {
		foreach( $result['retfields'] as $key => $value ) 
			$result = $client->service_redir_delete( $username, $password, $domain, "mail", $key, $value );
		}

	// add all defined mail redirect
	foreach ($params["prefix"] AS $key=>$value) {

		$source = $params["prefix"][$key] . "@" . $domain;
		$destination = $params["forwardto"][$key];

		// invalid email syntaxe
		if ( !mb_eregi( "^[a-zA-Z0-9+._-]+@[a-zA-Z0-9.-]{2,}\.[a-zA-Z]{2,6}$", $source ) ) continue;
		if ( !mb_eregi( "^[a-zA-Z0-9+._-]+@[a-zA-Z0-9.-]{2,}\.[a-zA-Z]{2,6}$", $destination ) ) continue;

		// invalid email (not delivrable)
		if ( valid_email( $destination ) == "" ) continue;

        try { $result = $client->service_redir_create( $username, $password, $domain, "mail", $source, $destination ); }
        catch (SoapFault $fault) { return( array('error' => "SOAP error handler SaveEmailForwarding() / service_redir_create()" ) ); }

		if ( $result['retcode'] == -1 ) {
			$values["error"] = "service_redir_create error ".$domain."\n<br>";
			}
		}

	return ($values);
}

function bookmyname_GetURLForwarding($params) {
	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];	
	# Put your code to get url forwarding setting here
	$values["enabled"] = "true";
	$values["address"] = $urlforwardingaddr;

	//web_email_debug( $params );

	return $values;
}

function bookmyname_SaveURLForwarding($params) {
	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];
	//$forwardingurl = params["address"];
	# Put your code to get save forwarding url here

	//web_email_debug( $params );
}

function bookmyname_GetAuthCode( $params ) {

	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];

	$domain = $params["sld"].".".$params["tld"];
	$values["error"] = "";

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);
    try {

    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

   	$result = $client->domain_info( $username, $password, $domain );
    }
    catch (SoapFault $fault) {
            return( array('error' => "SOAP error handler GetAuthCode() / domain_info()" ) );
        }

	$values["error"] = "";

	if ( $result['retcode'] == 1 ) {
		if ( isset( $result['retfields']['authinfo'] ) )
			$values["authcode"]= $result['retfields']['authinfo'];
		}
	else {
		$values["error"] = "Unable to get AuthCode";

        if ( $result['retcode'] == -1 && $result['retval'] == -1 ) $values["error"] .= " / login or password error";
        if ( $result['retcode'] == -1 && $result['retval'] == -2 ) $values["error"] .= " / owner/admin/tech/bill permission denied";
        if ( $result['retcode'] == -1 && $result['retval'] == -3 ) $values["error"] .= " / domain undef";
        if ( $result['retcode'] == 0 && $result['retval'] == 0 ) $values["error"] .= " / domain unknown in database";

        logModuleCall( "bookmyname", "GetAuthCode", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );
        }

	return ( $values );
}

function bookmyname_GetDns( $params ) {

	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$domain = $params["sld"].".".$params["tld"];

	//web_email_debug( $params );

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

	try {

    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

	// web redirect
  	$result = $client->service_redir_list( $username, $password, $domain, "web" );
	} catch (SoapFault $fault) {
            return( array('error' => "SOAP error handler GetDns() / service_redir_list()" ) );
        }

	if ( $result['retcode'] == -1 ) {
		$values["error"] = "service_redir_list error ".$domain."\n<br>";
		return( $values );
		}

	$counter = 0;
	foreach( $result['retfields'] as $key => $value ) {
		$key = str_replace( "http://", "", $key );
		$key = str_replace( ".".$domain, "" , $key );
		$values[ $counter ]["hostname"] = $key;
		$values[ $counter ]["type"] = "URL";
		$values[ $counter ]["address"] = $value;
		$counter++;
		}

	// web redirect (in frame)
    	$result = $client->service_redir_list( $username, $password, $domain, "rweb" );
	if ( $result['retcode'] == -1 ) {
		$values["error"] = "service_redir_list error ".$domain."\n<br>";
		return( $values );
		}
	foreach( $result['retfields'] as $key => $value ) {
		$key = str_replace( "http://", "", $key );
		$key = str_replace( ".".$domain, "" , $key );
		$values[ $counter ]["hostname"] = $key;
		$values[ $counter ]["type"] = "FRAME";
		$values[ $counter ]["address"] = $value;
		$counter++;
		}

	// custom dns entry
	$result = $client->service_dns_custom_get( $username, $password, $domain );
	if ( $result['retcode'] == -1 ) {
		$values["error"] = "service_dns_custom_get error ".$domain."\n<br>";
		return( $values );
		}

	for ( $i=0; $i<$result['retval']; $i++ ) {
		$values[ $counter ]["hostname"] = $result['retfields'][$i]['name'];
		$values[ $counter ]["type"] = $result['retfields'][$i]['type'];
		$values[ $counter ]["address"] = $result['retfields'][$i]['value'];
		$counter++;
		}

	return $values;

}

function bookmyname_SaveDns( $params ) {

	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];

	//web_email_debug( $params );

	$values["error"] = "";

	$domain = $params["sld"].".".$params["tld"];


    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

    try {

    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

	$countrweb = 0;
	$countweb = 0;
	$countcustom = 0;
	for( $i=0; $i<count($params['dnsrecords']); $i++ ) {
		if ($params["dnsrecords"][$i]['type']=='FRAME')
			$countrweb++;
		else
		if ($params["dnsrecords"][$i]['type']=='URL')
			$countweb++;
		else
			$countcustom++;
		}

	// delete all existing web redirect
	if ( $countweb ) {
	    	$result = $client->service_redir_list( $username, $password, $domain, "web" );
		if ( $result['retcode'] == 1 ) {
			foreach( $result['retfields'] as $key => $value ) 
				$result = $client->service_redir_delete( $username, $password, $domain, "web", $key, $value );
			}
		}

	// delete all existing FRAME web redirect
	if ( $countrweb ) {
	    	$result = $client->service_redir_list( $username, $password, $domain, "rweb" );
		if ( $result['retcode'] == 1 ) {
			foreach( $result['retfields'] as $key => $value ) 
				$result = $client->service_redir_delete( $username, $password, $domain, "rweb", $key, $value );
			}
		}


	$customzone = "";

	// registrer all new informations.
	for( $i=0; $i<count($params['dnsrecords']); $i++ ) {

	if ( !isset( $params["dnsrecords"][$i]['hostname'] ) ) continue;
	if ( !isset( $params["dnsrecords"][$i]['type'] ) ) continue;
	if ( !isset( $params["dnsrecords"][$i]['address'] ) ) continue;

	$hostname = $params["dnsrecords"][$i]['hostname'];
	$type = $params["dnsrecords"][$i]['type'];
	$address = $params["dnsrecords"][$i]['address'];

	if ( $hostname == "" && $address == "" ) continue;

	if ( $type == 'URL' || $type == 'FRAME' ) {

		$hostname = str_replace( "http://", "", $hostname );
		$hostname = "http://".$hostname;
		if ( strstr( $hostname, ".".$domain ) == FALSE ) 
			$hostname .= ".".$domain;

		if ( strstr( $address, "://" ) == FALSE )
			$address = "http://".$address;
		
		if ( valid_url( $address, 1 )=="" ) 
			$values["error"] .= "Invalid (ad) ".$address;
		else
		if ( valid_url( $hostname, 0 )=="" ) 
			$values["error"] .= "Invalid (hn) ".$hostname;
		else {

			if ( $type == "URL" ) $type="web";
			if ( $type == "FRAME" ) $type="rweb";
		
			$result = $client->service_redir_create( $username, $password, $domain, $type, $hostname, $address );

			if ( $result['retcode'] == -1 ) 
				$values["error"] .= "service_redir_create error ".$domain."\n<br>";
			}
		}
	else
	if ( $type=='A' || $type=='AAAA' || $type=='CNAME' || $type=='MX' || $type=='SPF' || $type=='MXE' /*curious*/ ) {

		if ( $type=='SPF' ) $type='TXT';

		// Quick control to denied stupid input before full test in BookMyName API.
		$err=0;
		$match = "^[a-zA-Z0-9@.-]+$";
		if ( !mb_eregi( $match, $hostname ) ) {
	                $values["error"] .= sprintf("Syntax error (%s) in (%s %s %s)<BR>\n",  $hostname, $hostname, $type, $address );
			$err++;
			}
		if ( $type=='A' && valid_ipv4( $address )=="" ) {
			if ( valid_ipv6( $address )!="" )
				$type='AAAA';
			else {
		                $values["error"] .= sprintf("Invalid IPv4 (%s %s %s)<BR>\n",  $hostname, $type, $address );
				$err++;
				}
			}
		if ( $type=='AAAA' && valid_ipv6( $address )=="" ) {
	                $values["error"] .= sprintf("Invalid IPv6 (%s %s %s)<BR>\n",  $hostname, $type, $address );
			$err++;
			}
		if ( $type=='MX' || $type=='MXE' ) {
			if ( $type=='MXE' ) $type='MX';

			$afields = explode( " ", $address );
			// set weight if not available
			if ( count($afields)==1 ) 
				$address .= "100 ".$address;
			else
			if ( count($afields)!=2 ) {
	                	$values["error"] .= sprintf("Syntax error (%s) In (%s %s %s)<BR>\n", $address,  $hostname, $type, $address );
				$err++;
				}
			else
			if ( count($afields)==2 && $afields[0]==0 ) {
                                $values["error"] .= sprintf("Syntax error (%s) In (%s %s %s)<BR>\n", $address,  $hostname, $type, $address );
                                $err++;
                                }
			}

		if ( $err==0 ) 
			$customzone .= sprintf("%s %s %s\n", $hostname, $type, $address );
		}
	}

	// custom dns entry (replace zone)
	if ( $countcustom || strlen( $customzone) ) {
		$result = $client->service_dns_custom_set( $username, $password, $domain, $customzone );
		if ( $result['retcode'] == -1 ) {
			$values["error"] .= "service_dns_custom_set error ".$domain."<BR>\n";
            logModuleCall( "bookmyname", "SaveDns", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );
			return( $values );
		}
	}

	}
    catch (SoapFault $fault) {
          return( array('error' => "SOAP error handler SaveDns()" ) );
        }

	return ($values);
}

function bookmyname_RegisterDomain($params) {

    // Enregistrement de .EU par l'EurID
    $pays_eurid = array( 1,89,100,149,189,1,11,12,13,15,31,49,72,73,74,83,88,97,111,117,132,138,139,147,185,186,190,207,208,213,219,238 );

    // Enregistrement de TLDs gere par AFNIC
    $pays_afnic = array( 1,89,90,91,100,149,152,166,189,196,247,112,174,14,137,1,11,12,13,15,31,49,72,73,74,83,88,97,111,117,132,138,139,147,185,186,190,207,208,213,219,238 );

    // liste des TLDs que gere l'AFNIC
    $atldafnic = array( 'fr','re','wf','tf','pm','yt' );


	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$domain = $params["sld"].".".$params["tld"];

	$values["error"] = "";

	// no 8 bits charset (map 2 ascii)
	$params = array2asc( $params );

	//web_email_debug( $params );

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

    try {
    $url = "http://api.bookmyname.com/apis.cgi";
    if ( $testmode == "on" )
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

	// check if domain is realy available
	$result = $client->domain_check( $username, $password, $domain );
    } catch (SoapFault $fault) {
            return( array('error' => "SOAP error handler RegisterDomain() / domain_check()" ) );
        }

    //web_email_debug( array('domain_check result[]', $result ) );
    if ( $result['retcode'] == -1 )
        logModuleCall( "bookmyname", "RegisterDomain/domain_check", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );

    if ( $result['retcode'] == -1 && $result['retval'] == -1 ) {
        $values["error"] = "ERROR: login or password error\n<br>";
		return ( $values );
        }
    if ( $result['retcode'] == -1 && $result['retval'] == -2 ) {
        $values["error"] = "ERROR: domain name ".$domain." ** IS NOT AVAILABLE ** -2\n<br>";
		return ( $values );
        }
    if ( $result['retcode'] == -1 && $result['retval'] == -3 ) {
        $values["error"] = "ERROR: bad TLD\n<br>";
		return ( $values );
        }
    if ( $result['retcode'] == -1 && $result['retval'] == -4 ) {
        $values["error"] = "ERROR: domain name ".$domain." ** IS NOT AVAILABLE ** -4\n<br>";
		return ( $values );
        }
    if ( $result['retcode'] == -1 && $result['retval'] == -5 ) {
        $values["error"] = "ERROR: domain undef\n<br>";
		return ( $values );
        }
 
	if ( $result['retcode'] != 1 && $result['retval'] != 1 ) {
		$values["error"] = "Error domain name ".$domain." ** IS NOT AVAILABLE ** ".$result['retcode']."/".$result['retval']."\n<br>";
		return ( $values );
		}

    //web_email_debug( array('avant map_paysid() params[country]', $params["country"] ) );

	$pays_id = map_paysid( $params["country"] );
	$region_id = ""; // state = $params["state"];

    //web_email_debug( array('apres map_paysid() pays_id', $pays_id ) );

	// fix stupid phone number format
	if ( isset( $params["fullphonenumber"] ) )
		$phone = $params["fullphonenumber"];
    else
        $phone = $params["phonenumber"];

    $phone = str_replace( array(" ","-","(",")"), array("","","",""), $phone );

    // controle la syntaxe ( +nnn.nnnnn )
    if (preg_match( "/^(\+[0-9]{1,4}\.)([0-9 ]*)$/i", $phone, $match )) {
	    $prefix = $match[1];
    	$numero = $match[2];
        if ( "+33." == $prefix  ) {
    		while( strlen($numero) > 9 )
    			$numero = substr( $numero, 1 );
    		while( strlen($numero) < 9 )
    			$numero = $numero."0";

            $phone = $prefix.$numero;
    		}
	    }
    else
        $phone = reformat_telephone( $phone );

	$hash_email = "no";
	if ( $params["idprotection"]==1 ) $hash_email = "yes";
	$lang = "en";
	if ( $params["country"]=='FR' ) $lang='fr';
	if ( $params["country"]=='ES' ) $lang='es';
	if ( $params["country"]=='DE' ) $lang='de';

	$formj = "Societe";
  	if ( $params["companyname"]=="" ) 
   		$formj = "Particulier";

	$nexus_p = $nexus_c = "";
    if ( strtoupper( $params["tld"] ) == 'US' ) {
    	$nexus_p = 'P3';
    	$nexus_c = 'C31';
    	if ( $params["companyname"]=="" ) {
    		$formj = "Particulier";
    		if ( $pays_id==7 )
    			$nexus_c = 'C11';
    		}
    	else {
    		$formj = "Societe";
    		if ( $pays_id==7 ) {
    			$nexus_p = 'P1';
    			$nexus_c = 'C21';
    			}
    		}
        }

	if ( in_array( strtoupper( $params["tld"] ), array('EU','IT','ES') ) && !is_cee_country( $pays_id ) ) {
		$values["error"] = "You must have Europeen address to register a .EU, .IT, .ES\n<br>";
		return ( $values );
		}

    $itpin = '';
    if (  strtoupper( $params["tld"] ) == 'IT' ) {
        /*
            // En fonction du titulaire:
            // . Particulier Italien => Codice Fiscale (16 characteres).
            // . Particulier qui n'est pas Italien => Numro de passport.
            // . Associations numero de TVA => "Pin" = "n.a."
            // . Dans tout les autres cas, le "Pin" doit tre un numro de TVA intracommunautaire
        */
        if ( isset( $params['additionalfields']['Tax ID'] ) ) $itpin = $params['additionalfields']['Tax ID'];

        if ( strlen( $itpin ) < 4 ) {
            $values["error"] = "Tax ID missing. (IT Codice Fiscale, or passport number, or VAT intracom number)\n<br>";
            return ( $values );
            }
        }

    $ukmode = '';
    if ( in_array( strtoupper( $params["tld"] ), array ('UK','CO.UK','ORG.UK','ME.UK') ) ) {

        // http://registrars.nominet.uk/registration-and-domain-management/field-definitions-and-registrant-types
        /*
        LTD     UK Limited Company
        PLC     UK Public Limited Company
        PTNR    UK Partnership
        STRA    UK Sole Trader
        LLP     UK Limited Liability Partnership
        IP      UK Industrial/Provident Registered Company
        IND     UK Individual (representing self)
        SCH     UK School
        RCHAR   UK Registered Charity
        GOV     UK Government Body
        CRC     UK Corporation by Royal Charter
        STAT    UK Statutory Body
        OTHER   UK Entity that does not fit into any of the above (e.g. clubs, associations, many universities)
        FIND    Non-UK Individual (representing self)
        FCORP   Non-UK Corporation
        FOTHER  Non-UK Entity that does not fit into any of the above (e.g. charities, schools, clubs, associations)
        */

        $amapuk = array (
            "Individual" => "IND",
            "UK Limited Company" =>  "LTD",
            "UK Public Limited Company" => "PLC" ,
            "UK Partnership" => "PTNR" ,
            "UK Limited Liability Partnership" => "LLP",
            "Sole Trader" =>  "STRA",
            "UK Registered Charity" => "RCHAR",
            "UK Entity (other)" => "OTHER",
            "Foreign Organization" => "FCORP",
            "Other foreign organizations" => "FOTHER",
            "UK Industrial/Provident Registered Company" => "IP",
            "UK School" => "SCH",
            "UK Government Body" => "GOV",
            "UK Corporation by Royal Charter" => "CRC",
            "UK Statutory Body" => "STAT",
            "Non-UK Individual" => "FIND"
            );

        if ( !isset( $amapuk[ $params['additionalfields']['Legal Type'] ] ) ) {
            $values["error"] = "Invalid UK Legal Type: ".$params['additionalfields']['Legal Type']."\n<br>";
            return ( $values );
            }
        $ukmode = $amapuk[ $params['additionalfields']['Legal Type'] ];
        if ( $ukmode == 'FIND' || $ukmode == 'IND' )
            $ukconumber = '';
        else
            $ukconumber = $params['additionalfields']['Company ID Number'];
        }

    $espin = '';
    if (  strtoupper( $params["tld"] ) == 'ES' ) 
        $espin =  $params['additionalfields']['ID Form Number'];

    //web_email_debug( array('apres is_cee_country, pays_id', $pays_id ) );

	$frmode = $siret = $nele = $necp = $neville = $duns = "";
	$nepays = "France";

    // controle specifique a l'AFNIC
    if ( in_array( strtolower( $params["tld"] ), $atldafnic ) ) {

        // Ouverture a l'Europe des TLDs AFNIC
    	if ( !in_array( $pays_id, $pays_afnic ) ) {
    		$values["error"] = sprintf( "Owner invalid country to register AFNIC tlds (pays_id=%d/%d)\n<br>", $pays_id, count($pays_afnic) );
    		return ( $values );
    		}

        if ( isset( $params['additionalfields']['DUNS Number'] ) ) $duns = $params['additionalfields']['DUNS Number'];
    	if ( isset( $params['additionalfields']['SIRET Number'] ) ) $siret = $params['additionalfields']['SIRET Number'];
    	if ( isset( $params['additionalfields']['Birthdate'] ) ) $nele = $params['additionalfields']['Birthdate'];
    	if ( isset( $params['additionalfields']['Birthplace Postcode'] ) ) $necp =  $params['additionalfields']['Birthplace Postcode'];
    	if ( isset( $params['additionalfields']['Birthplace City'] ) ) $neville = $params['additionalfields']['Birthplace City'];
    	if ( isset( $params['additionalfields']['Birthplace Country'] ) ) $nepays = $params['additionalfields']['Birthplace Country'];

        //web_email_debug( array('siret'=>$siret, 'nele'=>$nele, 'necp'=>$necp, 'neville'=>$neville ) );

    	if ( $siret=="" && $nele=="" && $necp=="" && $neville=="" ) {
    		$values["error"] = "Information missing (DUNS,SIRET,Birthdate,Birthplace) to be able to create an AFNIC domain\n<br>";
    		return ( $values );
    		}

    	if ( strlen( $siret ) && strlen($params["companyname"]) && $formj == "Societe" && control_siret_siren( $siret ) != 0 ) 
    		$frmode = "SIRET";
        else
        if ( strlen( $duns ) > 7 && "Societe" == $formj ) 
            $frmode = "DUNS";
    
        if ( '' == $duns && '' == $siret && 'Particulier' != $formj && strlen($nele) )
            $formj='Particulier';

    	$nele = str_replace( "/", "-", $nele ); // date saisie avec des "/" comme separateur
    	$clock = strtotime( $nele );
    	if ( strlen( $params["lastname"] ) && strlen( $params["firstname"] ) && $formj == "Particulier" &&
    		$clock != 0 && $clock < (time() - 18*86400*365) && $clock > (time() - 100*86400*365)   ) {

    		$frmode = 'PARTICULIER';
    		$nele = strftime( "%d-%m-%Y", $clock ); // reformate a un look stantard

    		if (  1 == $pays_id &&  ($necp < 1000 || $necp > 98890 ) ) {
    			$values["error"] = "Code postal du lieu de naissance invalide ".$necp."\n<br>";
    			return ( $values );
    			}
            else if ( 1 == $pays_id )
    		    $necp = sprintf("%05d", $necp );

    		if ( strlen($neville) < 1 ) {
    			$values["error"] = "Ville du lieu de naissance invalide\n<br>";
    			return ( $values );
    			}
    		}

    	if ( strlen($params["postcode"]) != 5 ) {
    		$values["error"] = "Code postal invalide (".$params["postcode"].") <> 5 caracteres\n<br>";
    		return ( $values );
    		}

    	if ( $frmode == "" ) {
    		$values["error"] = "Invalid or missing information to be able to create a .FR\n<br>";
    		return ( $values );
    		}

    	$params['lastname'] = ucfirst( trim(iso2asc( $params['lastname'] ) ) );
    	$params['firstname'] = ucfirst( trim(iso2asc( $params['firstname'] ) ) );
    	$params['companyname'] = strtoupper( trim(iso2asc( $params['companyname'] ) ) );

    	}

	$newcontact = array (

        "passwd" => $params["password"],
        "email" => $params["email"],
        //"hash_email" => $hash_email,
        "formejuridique" => $formj,
        "civilite" => "",
        "nom" => $params["lastname"],
        "prenom" => $params["firstname"],
        "societe" => $params["companyname"],
        "adresse1" => $params["address1"],
        "adresse2" => $params["address2"],
        "cp" => "".$params["postcode"],
        "ville" => $params["city"],
        "region_id" => $region_id,
        "pays_id" => $pays_id,
        "telephone" => $phone,
        "telecopie" => "",
        "numero_tva" => "",
        "siret" => $siret,
        "marque" => "",
        "lang" => $lang,
        "revente" => "no",

	// NEXUS (utile uniquement pour le ccTLD .US)
        "dotus_nexus_purpose" => $nexus_p, 
            // "P1" Business
            // "P2" Non-Profit Business
            // "P3" Personal Use
            // "P4" Education
            // "P5" Goverment
        "dotus_nexus_category" => $nexus_c,
            // "C11" U.S. Citizen
            // "C12" U.S. Permanent Resident
            // "C21" U.S. Organization Incorprated in U.S.
            // "C31" Non-US: Regularly engages in lawful activities in U.S.
            // "C32" Non-US: Entity has an office or other facility in U.S.

	// Extensions (utile uniquement pour le ccTLD .FR)
 
	// Choix de la methode d'authentification par l'AFNIC
	// ATTENTION il doit y avoir une coherence entre la forme juridique 
	// et le mode d'authentification de l'AFNIC
 
        "dotfr_mode" => $frmode,         // enum('MARQUE','SIRET','PARTICULIER','ASSOCIATION')
        "dotfr_marque" => "",       // une marque de l'INPI
        "dotfr_ne_le" => $nele,        // date de naissance sous la forme: (JJ-MM-AAAA)
        "dotfr_ne_cp" => $necp,        // code postal du lieu de naissance
        "dotfr_ne_ville" => $neville,     // ville du lieu de naissance
        "dotfr_ne_pays_id" => "1",  // pays du lieu de naissance - voir api_paysid();
        "dotfr_publication_jo" => "", // date de publication au journal officiel sous la forme: (JJ-MM-AAAA)
        "dotfr_publication_jo_page" => "", // numero de page de la publication au journal officiel
        "dotfr_duns" => $duns,
        "dotfr_local" => "",

        );

    if ( $itpin != '' )
        $newcontact[ "dotit_pin" ] = $itpin;

    if ( $espin != '' )
        $newcontact[ "dotes_pin" ] = $espin;

    if ( $ukmode != '' ) {
        $newcontact[ "dotuk_mode" ] = $ukmode;
        $newcontact[ "dotuk_co_number" ] = $ukconumber;
        }


    //web_email_debug( array('SOAP contact_create', $params['additionalfields'] ) );

    try {
	$result = $client->contact_create( $username, $password, $newcontact );
    } catch (SoapFault $fault) {
            return( array('error' => "SOAP error handler RegisterDomain() / contact_create()" ) );
        }

	if ( $result['retcode'] != 1 ) {
        $errinfo = '';
        if ( isset($result['retfields']['need']) ) $errinfo = $result['retfields']['need'];
        $values["error"] = "Error unable to create contact. retcode=".$result['retcode']." reval=".$result['retval']." ".$errinfo."\n<br>";

		//ob_start(); echo "<PRE>"; print_r( $result ); echo "</PRE>"; $values["error"] .= ob_get_contents(); ob_end_clean();

        logModuleCall( "bookmyname", "RegisterDomain/contact_create", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );

		return ( $values );
		}

	// owner
	$id = $result['retval'];

	$regperiod = $params["regperiod"];
	if ( $regperiod < 1 || $regperiod > 10 )
		$regperiod = 1;

	$newdomain = array(
        "domain"   => $domain, 
        "period"   => $regperiod,
        "owner_id" => $id,
        "admin_id" => $username, // Contact Admin = revendeur 
        "tech_id"  => $username, // Contact Technique = revendeur
        "bill_id"  => $username, // Contact Facturation = revendeur
        "service"  => "dns",
        "ns0" => $params["ns1"],
        "ns1" => $params["ns2"],
        "ns2" => $params["ns3"],
        "ns3" => $params["ns4"],
        );

    try {
	$result = $client->domain_create( $username, $password, $newdomain );
    } catch (SoapFault $fault) {
            return( array('error' => "SOAP error handler RegisterDomain() / domain_create()" ) );
        }

	if ( $result['retcode'] != 1 ) {

        $comment = '';
        if ( $result['retcode'] == -1 && $result['retval'] == -2 ) $comment = 'domain name not available';
        if ( $result['retcode'] == -1 && $result['retval'] == -3 ) $comment = 'missing contact data';
        if ( $result['retcode'] == -1 && $result['retval'] == -4 ) $comment = 'invalid owner_id,admin_id,tech_id,bill_id';
        if ( $result['retcode'] == -1 && $result['retval'] == -6 ) $comment = 'missing contact data for ccTLD .FR,.US,.IT,.UK,.ES,...';
        if ( $result['retcode'] == -1 && $result['retval'] == -7 ) $comment = 'invalid DNS or ZoneCheck';
        if ( $result['retcode'] == -1 && $result['retval'] == -8 ) $comment = 'invalid DNS, hostname not defined at registry';
        if ( $result['retcode'] == -1 && $result['retval'] == -9 ) $comment = 'invalid DNS, missing IP for glue record';

		$values["error"] = "Error unable to create domain ".$domain." (".$comment.")\n<br>";

        logModuleCall( "bookmyname", "RegisterDomain/domain_create", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );

		//ob_start(); echo "<PRE>"; print_r( $result ); echo "</PRE>"; $values["error"] .= ob_get_contents(); ob_end_clean();

		return ( $values );
		}

	return $values;
}

function bookmyname_TransferDomain($params) {

    $transin_tlds_ok = array( 
    'academy','accountant','accountants','actor','agency','alsace','apartments','asia','associates','at','audio',
    'band','bar','bargains','be','beer','bid','bike','bingo','biz','black','blackfriday','blog',
    'blue','boutique','builders','business','bzh','cab','cafe','camera','camp','capital','cards','care',
    'careers','casa','cash','casino','catering','cc','center','ch','chat','cheap','christmas','church',
    'city','claims','cleaning','click','clinic','clothing','club','co','coach','codes','coffee','college',
    'com','community','company','computer','condos','construction','consulting','contractors','cooking','cool','country','coupons',
    'credit','creditcard','cricket','cruises','dance','date','dating','de','deals','delivery','democrat','dental',
    'design','diamonds','diet','digital','direct','directory','discount','doctor','dog','domains','download','education',
    'email','energy','engineering','enterprises','equipment','estate','eu','events','exchange','expert','exposed','express',
    'fail','faith','family','fans','farm','fashion','finance','financial','fish','fishing','fit','fitness',
    'flights','florist','flowers','fm','football','forsale','foundation','fr','fund','furniture','futbol','fyi',
    'gallery','game','games','garden','gift','gifts','glass','global','gmbh','gold','golf','graphics',
    'gratis','green','gripe','group','guide','guitars','guru','haus','healthcare','help','hiphop','hiv',
    'hockey','holdings','holiday','horse','host','hosting','house','immo','immobilien','in','industries','info',
    'ink','institute','insure','international','investments','io','irish','it','jetzt','jewelry','juegos','kaufen',
    'kim','kitchen','land','lease','legal','lgbt','li','life','lighting','limited','limo','link',
    'live','loan','loans','lol','love','ltd','lu','maison','management','marketing','mba','me',
    'media','memorial','men','mobi','moda','mom','money','movie','name','net','network','news',
    'ninja','online','org','paris','partners','parts','party','photo','photography','photos','pics','pictures',
    'pink','pizza','place','plumbing','plus','pm','poker','press','pro','productions','properties','property',
    'proprety','protection','pub','racing','re','realty','recipes','red','reise','reisen','rent','rentals',
    'repair','report','republican','rest','restaurant','review','reviews','rip','rocks','rodeo','run','sale',
    'salon','sarl','school','schule','science','security','services','sex','sexy','shoes','shopping','show',
    'singles','site','ski','soccer','social','solar','solutions','space','store','studio','style','supplies',
    'supply','support','surf','surgery','systems','tattoo','tax','taxi','team','tech','technology','tel',
    'tennis','tf','theater','theatre','tienda','tips','tires','today','tools','tours','town','toys',
    'trade','training','tv','tw','uk','university','us','vacations','ventures','viajes','video','villas',
    'vin','vision','vodka','vote','voto','voyage','watch','webcam','website','wedding','wf','wiki',
    'win','wine','work','works','world','ws','wtf','xyz','yoga','yt','zone',
    );

	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];
	$regperiod = $params["regperiod"];
	if ( $regperiod < 1 || $regperiod > 10 )
		$regperiod = 1;
	$transfersecret = $params["transfersecret"];

	# Put your code to transfer domain here
	# If error, return the error message in the value below
	$values["error"] = $error;

	if ( !in_array( $tld, $transin_tlds_ok ) ) {
		$values["error"] = "Transfert for <B>".$tld."</B> domain name is not supported";
		return( $values );
		}

	$domain = $params["sld"].".".$params["tld"];

	//web_email_debug( $params );

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

    try {
    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

	if ( $regperiod < 1 || $regperiod > 10 )
		$regperiod = 1;


    // Create new customer contact for transfert
    $lang = "en";
    if ( $params["country"]=='FR' ) $lang='fr';
    if ( $params["country"]=='ES' ) $lang='es';
    if ( $params["country"]=='DE' ) $lang='de';

    $params['lastname'] = ucfirst( trim(iso2asc( $params['lastname'] ) ) );
    $params['firstname'] = ucfirst( trim(iso2asc( $params['firstname'] ) ) );
    $params['companyname'] = strtoupper( trim(iso2asc( $params['companyname'] ) ) );

	$formj = "Societe";
  	if ( $params["companyname"]=="" ) $formj = "Particulier";

    $pays_id = map_paysid( $params["country"] );
    $region_id = ""; // state = $params["state"];

    // fix stupid phone number format
    if ( isset( $params["fullphonenumber"] ) )
        $phone = $params["fullphonenumber"];
    else
        $phone = $params["phonenumber"];

    $phone = str_replace( array(" ","-","(",")"), array("","","",""), $phone );
    // controle la syntaxe ( +nnn.nnnnn )
    if (preg_match( "/^(\+[0-9]{1,4}\.)([0-9 ]*)$/i", $phone, $match )) {
        $prefix = $match[1];
        $numero = $match[2];
        if ( "+33." == $prefix  ) {
            while( strlen($numero) > 9 )
                $numero = substr( $numero, 1 );
            while( strlen($numero) < 9 )
                $numero = $numero."0";

            $phone = $prefix.$numero;
            }
        }
    else
        $phone = reformat_telephone( $phone );

    $newcontact = array (
        "passwd" => $params["password"],
        "email" => $params["email"],
        "formejuridique" => $formj,
        "civilite" => "",
        "nom" => $params["lastname"],
        "prenom" => $params["firstname"],
        "societe" => $params["companyname"],
        "adresse1" => $params["address1"],
        "adresse2" => $params["address2"],
        "cp" => "".$params["postcode"],
        "ville" => $params["city"],
        "region_id" => $region_id,
        "pays_id" => $pays_id,
        "telephone" => $phone,
        "telecopie" => "",
        "numero_tva" => "",
        "siret" => $siret,
        "marque" => "",
        "lang" => $lang,
        "revente" => "no"
        );

    try {
    $result = $client->contact_create( $username, $password, $newcontact );
    } catch (SoapFault $fault) {
            return( array('error' => "SOAP error handler TransferDomain() / contact_create()" ) );
        }

    if ( $result['retcode'] != 1 ) {
        $errinfo = '';
        if ( isset($result['retfields']['need']) ) $errinfo = $result['retfields']['need'];
        $values["error"] = "Error unable to create contact. retcode=".$result['retcode']." reval=".$result['retval']." ".$errinfo."\n<br>";

        //ob_start(); echo "<PRE>"; print_r( $result ); echo "</PRE>"; $values["error"] .= ob_get_contents(); ob_end_clean();

        logModuleCall( "bookmyname", "TransferDomain", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );

        return ( $values );
        }

    // owner
    $newowner_id = $result['retval'];

    // RGPD new transfert process, with owner contact 
	$result = $client->domain_transfer( $username, $password, $domain, $transfersecret, $newowner_id );

    } catch (SoapFault $fault) {
            $values["error"] = "SOAP error handler TransferDomain()";
            return ( $values );
    }

	if ( $result['retcode'] != 1 ) {
		$values["error"] = "Error unable to transfer domain ".$domain."\n<br>";

		ob_start(); echo "<PRE>"; print_r( $result ); echo "</PRE>"; $values["error"] .= ob_get_contents(); ob_end_clean();

        logModuleCall( "bookmyname", "TransferDomain", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );

		return ( $values );
		}

	return $values;
}

function bookmyname_RenewDomain($params) {

	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];
	$regperiod = $params["regperiod"];

	# Put your code to renew domain here
	# If error, return the error message in the value below
	$values["error"] = "";

	$domain = $params["sld"].".".$params["tld"];

	//web_email_debug( $params );

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

	if ( $regperiod < 1 || $regperiod > 10 ) {
		$values["error"] = "Error renew period < 1 or > 10";
		return ( $values );
		}
    /*
	if ( strtolower($params["tld"])=='uk' &&  $regperiod != 2 ) {
		$values["error"] = "Error renew period for .UK must be 2";
		return ( $values );
		}
    */

	if ( $regperiod < 1 || $regperiod > 10 ) 
		$regperiod = 1;
	if ( strtolower($params["tld"])=='uk' )
		$regperiod = 2;

    use_soap_error_handler(false);

    try {

    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

    	$result = $client->domain_renewable( $username, $password, $domain, $regperiod );

    } catch (SoapFault $fault) {
            return( array('error' => "SOAP error handler RenewDomain()" ) );
        }


	if ( $result['retcode'] != 1 && $result['retval'] != 1 ) {
		$values["error"] = "Error domain_renewable() unable to renew domain ".$domain."\n<br>";

		ob_start(); echo "<PRE>"; print_r( $result ); echo "</PRE>"; $values["error"] .= ob_get_contents(); ob_end_clean();

        logModuleCall( "bookmyname", "RenewDomain", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );

		return ( $values );
		}

    // seem to be renewable... proced...

    try {

    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

    	$result = $client->domain_renew( $username, $password, $domain, $regperiod );

    } catch (SoapFault $fault) {
            return( array('error' => "SOAP error handler RenewDomain()" ) );
        }

	if ( $result['retcode'] != 1 ) {
		$values["error"] = "Error unable to renew domain ".$domain."\n<br>";

		ob_start(); echo "<PRE>"; print_r( $result ); echo "</PRE>"; $values["error"] .= ob_get_contents(); ob_end_clean();

        logModuleCall( "bookmyname", "RenewDomain", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );

		return ( $values );
		}

	return $values;
}

function bookmyname_RestoreDomain($params) {

	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];
	$regperiod = $params["regperiod"];

	$values["error"] = "";

	$domain = $params["sld"].".".$params["tld"];

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    $regperiod = 1;

    use_soap_error_handler(false);

    try {

    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

    	$result = $client->domain_restorable( $username, $password, $domain );

    } catch (SoapFault $fault) {
            return( array('error' => "SOAP error handler RenewDomain()" ) );
        }

	if ( $result['retcode'] != 1 && $result['retval'] != 1 ) {
		$values["error"] = "Error domain_restorable() unable to restore domain ".$domain."\n<br>";

		ob_start(); echo "<PRE>"; print_r( $result ); echo "</PRE>"; $values["error"] .= ob_get_contents(); ob_end_clean();

        logModuleCall( "bookmyname", "RestoreDomain", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );

		return ( $values );
		}

    // Restore seem to be usable... proced

    try {

    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

    	$result = $client->domain_restore( $username, $password, $domain );

    } catch (SoapFault $fault) {
            return( array('error' => "SOAP error handler RenewDomain()" ) );
        }

	if ( $result['retcode'] != 1 ) {
		$values["error"] = "Error unable to restore domain ".$domain."\n<br>";

		ob_start(); echo "<PRE>"; print_r( $result ); echo "</PRE>"; $values["error"] .= ob_get_contents(); ob_end_clean();

        logModuleCall( "bookmyname", "RestoreDomain", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );

		return ( $values );
		}


	return $values;
}

function bookmyname_IDProtectToggle($params)
{
	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];

	$values["error"] = "";

	$domain = $params["sld"].".".$params["tld"];

	//web_email_debug( $params );

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

    try {
    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

  	$result = $client->domain_info( $username, $password, $domain );
    } catch (SoapFault $fault) {
            return( array('error' => "SOAP error handler IDProtectToggle() / domain_info()" ) );
        }

	if ( $result['retcode'] != 1 ) {
		$values["error"] = "domain_info failed ".$domain."\n<br>";
		ob_start(); print_r( $result ); $values["error"] .= ob_get_contents(); ob_end_clean();
		return $values;
		}

	$owner_id = $result['retfields']['owner_id'];

    use_soap_error_handler(false);

    try {
	$result = $client->contact_info( $username, $password, "", $owner_id );
	} catch (SoapFault $fault) {
            return( array('error' => "SOAP error handler IDProtectToggle() / contact_info()" ) );
        }

	if ( $result['retcode'] != 1 ) {
		$values["error"] = "contact_info failed ".$domain."\n<br>";
		ob_start(); print_r( $result ); $values["error"] .= ob_get_contents(); ob_end_clean();
        logModuleCall( "bookmyname", "IDProtectToggle", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );
		return $values;
		}

	$contact = $result['retfields'];

    // ??? proxy allready set as requested, do not need update
    /*
    if ( 1 == $params['protectenable'] && 'yes' == $contact['hash_email'] )
        return array( 'success' => 'success' );
    if ( 0 == $params['protectenable'] && 'no' == $contact['hash_email'] )
        return array( 'success' => 'success' );
    */

    // 201805 EU RGPD => id protected
    return array( 'success' => 'success' );


    if ( 1 == $params['protectenable'] ) 
        $contact['hash_email']='yes';
    else
        $contact['hash_email']='no';

	try {
	$result = $client->contact_update( $username, $password, $owner_id, $contact );
	} catch (SoapFault $fault) { 
             return( array('error' => "SOAP error handler IDProtectToggle() / contact_update()" ) );
        }

	if ( $result['retcode'] != 1 ) {
		$values["error"] = "contact_update failed ".$domain."\n<br><pre>";
		ob_start(); print_r( $result ); $values["error"] .= ob_get_contents(); ob_end_clean();
		$values["error"] .= "</pre>";
        logModuleCall( "bookmyname", "IDProtectToggle", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );
		return $values;
		}

    return array( 'success' => 'success' );
}

function bookmyname_GetContactDetails($params) {

	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];

	$domain = $params["sld"].".".$params["tld"];

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

    try {
    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

   	$result = $client->domain_info( $username, $password, $domain );
    } catch (SoapFault $fault) {
             return( array('error' => "SOAP error handler GetContactDetails() / domain_info()" ) );
        }


	if ( $result['retcode'] != 1 ) {
		$values["error"] = "domain_info failed ".$domain."\n<br>";
		ob_start(); print_r( $result ); $values["error"] .= ob_get_contents(); ob_end_clean();
		return $values;
		}

	$owner_id = $result['retfields']['owner_id'];
	$admin_id = $result['retfields']['admin_id'];
	//$tech_id = $result['retfields']['tech_id'];
	//$bill_id = $result['retfields']['bill_id'];

    try {
	$result = $client->contact_info( $username, $password, "", $owner_id );
	} catch (SoapFault $fault) {
             return( array('error' => "SOAP error handler GetContactDetails() / contact_info()" ) );
        }

	if ( $result['retcode'] != 1 ) {
		$values["error"] = "contact_info failed ".$domain."\n<br>";
		ob_start(); print_r( $result ); $values["error"] .= ob_get_contents(); ob_end_clean();
		return $values;
		}
	
	$values["Registrant"]["First Name"] = ucfirst( $result['retfields']['prenom'] );
	$values["Registrant"]["Last Name"] =  ucfirst( $result['retfields']['nom'] );
	if ( $result['retfields']['formejuridique'] != 'Particulier' )
		$values["Registrant"]["Company Name"] = $result['retfields']['societe'];;
	$values["Registrant"]["Email"] = $result['retfields']['email'];
	$values["Registrant"]["Phone Number"] = $result['retfields']['telephone'];
	$values["Registrant"]["Fax Number"] = $result['retfields']['telecopie'];
	$values["Registrant"]["Address1"] = $result['retfields']['adresse1'];
	$values["Registrant"]["Address2"] = $result['retfields']['adresse2'];
	$values["Registrant"]["Postcode"] = $result['retfields']['cp'];
	$values["Registrant"]["City"] =  $result['retfields']['ville'];

	// In most case, admin=reseller => dot not allow modification
    /*
	$result = $client->contact_info( $username, $password, "", $admin_id );
	if ( $result['retcode'] != 1 ) {
		$values["error"] = "domain_info failed ".$domain."\n<br>";
		ob_start(); print_r( $result ); $values["error"] .= ob_get_contents(); ob_end_clean();
		return $values;
		}

	$values["Admin"]["Email"] = $result['retfields']['email'];
	$values["Admin"]["Phone Number"] = $result['retfields']['telephone'];
	$values["Admin"]["Fax Number"] = $result['retfields']['telecopie'];
    */

	return $values;
}

function bookmyname_SaveContactDetails($params) {

	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];

	$domain = $params["sld"].".".$params["tld"];

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

    try {
  
    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

   	$result = $client->domain_info( $username, $password, $domain );
	} catch (SoapFault $fault) {
        return( array('error' => "SOAP error handler SaveContactDetails() / domain_info()" ) );
        }

	if ( $result['retcode'] != 1 ) {
		$values["error"] = "domain_info failed ".$domain."\n<br>";
		ob_start(); print_r( $result ); $values["error"] .= ob_get_contents(); ob_end_clean();
		return $values;
		}

	$owner_id = $result['retfields']['owner_id'];

    try {
	$result = $client->contact_info( $username, $password, "", $owner_id );
    } catch (SoapFault $fault) {
        return( array('error' => "SOAP error handler SaveContactDetails() / contact_info()" ) );
        }

	if ( $result['retcode'] != 1 ) {
		$values["error"] = "domain_info failed ".$domain."\n<br>";
		ob_start(); print_r( $result ); $values["error"] .= ob_get_contents(); ob_end_clean();
		return $values;
		}

	# Data is returned as specified in the GetContactDetails() function

	$values["error"] = "";
	
	$contact = $result['retfields'];

	if ( $params["contactdetails"]["Registrant"]["Company Name"] != $contact['societe'] ) {
		$values["error"] = "Company ownership transfert for domain name is unsupported";
		return ( $values );
		}

	if ( $contact['formejuridique']!='Particulier' ) {
		$contact['nom'] = $params["contactdetails"]["Registrant"]["Last Name"];
		$contact['prenom'] = $params["contactdetails"]["Registrant"]["First Name"];
		}

	$contact['email'] = $params["contactdetails"]["Registrant"]["Email"];
	$contact['telephone'] = reformat_telephone( $params["contactdetails"]["Registrant"]["Phone Number"] );
	if ( strlen($params["contactdetails"]["Registrant"]["Fax Number"] ) )
		$contact['telecopie'] = reformat_telephone( $params["contactdetails"]["Registrant"]["Fax Number"] );
	$contact['adresse1'] = $params["contactdetails"]["Registrant"]["Address1"];
	$contact['adresse2'] = $params["contactdetails"]["Registrant"]["Address2"];
	$contact['cp'] = $params["contactdetails"]["Registrant"]["Postcode"];
	$contact['ville'] = $params["contactdetails"]["Registrant"]["City"];

	try {
	$result = $client->contact_update( $username, $password, $owner_id, $contact );
	} catch (SoapFault $fault) { 
        return( array('error' => "SOAP error handler SaveContactDetails() / contact_update()" ) );
        }


	if ( $result['retcode'] != 1 ) {
		$values["error"] = "contact_update failed ".$domain."\n<br><pre>";
		ob_start(); print_r( $result ); $values["error"] .= ob_get_contents(); ob_end_clean();
		$values["error"] .= "</pre>";

        logModuleCall( "bookmyname", "SaveContactDetails", $params /*requestString*/, $result /*$responseData*/, ''/*$processedData*/, array( $username, $password ) /* $replaceVars */ );
		return $values;
		}

	return $values;
}

/* Sync Domain Status & Expiration Date. */
function bookmyname_Sync($params)
{
	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];

	$domain = $params["sld"].".".$params["tld"];

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

   use_soap_error_handler(false);

    try {
    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

  	$result = $client->domain_info( $username, $password, $domain );
	} catch (SoapFault $fault) {
        return( array('error' => "SOAP error handler Sync() / domain_info()" ) );
        }

    $active = 1;
    $transout = 0;
    $expired = 0;
    if ( $result['retfields']['registry_status'] & 0x00002000  ) $transout=1;
    if ( $result['retfields']['registry_status'] & (0x4|0x8)   ) $active=0;

    return array(
        'expirydate' => $result['retfields']['registrar_expiration'], // Format: YYYY-MM-DD
        'active' => (bool) $active,   // Return true if the domain is active
        'expired' => (bool) $expired, // Return true if the domain has expired
        'transferredAway' => (bool) $transout , // Return true if the domain is transferred out
    );
}

/* Incoming Domain Transfer Sync. */
function bookmyname_TransferSync($params)
{
	$username = $params["Username"];
	$password = $params["Password"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];

	$domain = $params["sld"].".".$params["tld"];

    if ( $username < 1 || strlen($password) < 6 )
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

    try {
    $url = "http://api.bookmyname.com/apis.cgi";
	if ( $testmode == "on" ) 
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

    $result = $client->api_pending_status( $username, $password, 2 /*2mois*/ );
	} catch (SoapFault $fault) {
        return( array('error' => "SOAP error handler TransferSync() / api_pending_status()" ) );
        }

    // Error? => No status change, return empty array
    if ( $result['retcode'] != 1 ) return ( array() );

    foreach( $result['retfields'] as $etat ) {
        if ( $etat['status'] == 'Wait' ) continue;
        if ( $etat['type'] != 'Domain' ) continue;
        if ( $etat['action'] != 'TransferRequest' ) continue;
        if ( strtolower($etat['domain']) != strtolower($domain) ) continue;
        if ( $etat['etat'] == 'Pending' ) return( array() );
        if ( $etat['status'] == 'Error' ) return( array( 'failed' => true, 'reason' => $etat['reply_msg'] ) );
    }

    // Not in pending...
    try {
    $url = "http://api.bookmyname.com/apis.cgi";
    if ( $testmode == "on" )
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

  	$result = $client->domain_info( $username, $password, $domain );
	} catch (SoapFault $fault) {
        return( array('error' => "SOAP error handler TransferSync() / domain_info()" ) );
        }

    // Error? => No status change, return empty array
    if ( $result['retcode'] != 1 ) return ( array() );

    // fini => Not in pending...
    return array( 'completed' => true, 'expirydate' => $result['retfields']['registrar_expiration'] ); // Format: YYYY-MM-DD
}

function bookmyname_GetEPPCode($params)
{
    $username = $params["Username"];
    $password = $params["Password"];
    $testmode = $params["TestMode"];
    $domain = $params["sld"].".".$params["tld"];

    //web_email_debug( $params );

    if ( $username < 1 || strlen($password) < 6 ) 
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

    try {
    $url = "http://api.bookmyname.com/apis.cgi";
    if ( $testmode == "on" )
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

   	$result = $client->domain_info( $username, $password, $domain );
    } catch (SoapFault $fault) {
        return( array('error' => "SOAP error handler GetEPPCode() / domain_info()" ) );
        }

    // Error? 
    if ( $result['retcode'] != 1 )
        return ( array( 'error' => "GetEPPCode domain_info() failed !") );

    // fake ok, in case or registry management
    if ( strtolower($tld)=='eu' || strtolower($tld)=='be' )
        return array( 'success' => 'success' );

    // real EPP authcode
    return array( 'eppcode' => $result['retfields']['authinfo'] );
}

/* Delete Domain */
function bookmyname_RequestDelete($params)
{
    $username = $params["Username"];
    $password = $params["Password"];
    $testmode = $params["TestMode"];
    $domain = $params["sld"].".".$params["tld"];

    if ( $username < 1 || strlen($password) < 6 ) 
        return( array('error' => 'BookMyName login error' ) );

    use_soap_error_handler(false);

    try {
    $url = "http://api.bookmyname.com/apis.cgi";
    if ( $testmode == "on" )
        $url = "http://api.dev.bookmyname.com/apis.cgi";
    $client = new SoapClient( NULL, array('location' => $url, 'uri' => $url, 'encoding'=>'UTF-8') );

   	$result = $client->domain_info( $username, $password, $domain );
    } catch (SoapFault $fault) {
        return( array('error' => "SOAP error handler RequestDelete() / domain_info()" ) );
        }

    // Error? 
    if ( $result['retcode'] != 1 )
        return ( array( 'error' => "domain_info() failed !") );

	$lockstatus="";
	$rstat = $result['retfields']['registry_status'];
	if ( $rstat & 0x01 ) $lockstatus.="clientDeleteProhibited,";
	if ( $rstat & 0x02 ) $lockstatus.="serverDeleteProhibited,";
	if ( $rstat & 0x04 ) $lockstatus.="clientHold,";
	if ( $rstat & 0x08 ) $lockstatus.="serverHold,";
	if ( $rstat & 0x100 ) $lockstatus.="clientUpdateProhibited,";
	if ( $rstat & 0x200 ) $lockstatus.="serverUpdateProhibited,";
	if ( $rstat & 0x400 ) $lockstatus.="pendingCreate,";
	if ( $rstat & 0x800 ) $lockstatus.="pendingDelete,";
	if ( $rstat & 0x2000 ) $lockstatus.="pendingTransfer";
    if ( "" != $lockstatus )
        return ( array( 'error' => "domain is locked (can't be deleted) ".$lockstatus) );

    if ( $result['retfields']['status'] != 'Active' )
        return ( array( 'error' => "domain status != 'Active'") );

    // SECURITY: permit to delete only the first 30 days after domain create
    $cdelmax = strtotime( $result['retfields']['registry_debut'] )+30*86400;
    if ( time() > $cdelmax ) 
        return ( array( 'error' => "can't delete, NOW > registry_create+30D") );

    try {
    	$result = $client->domain_delete( $username, $password, $domain );
    } catch (SoapFault $fault) {
        return( array('error' => "SOAP error handler RequestDelete() / domain_delete()" ) );
        }

    return array( 'success' => 'success' );
}

// reformate le telephone...
function reformat_telephone( $telephone, $indicatif_pays="" )
{
    $plus = 0;
    $pays = "";

    $scontrol = trim( $telephone );
    $l = strlen($scontrol);

    if ( !$l && !$indicatif_pays )
        return ( "+1.1" );

    if ( !$l && $indicatif_pays )
        return ( "+".$indicatif_pays.".1" );

    if ( strncmp( $scontrol, "00", 2 )== 0 ) 
        $scontrol = "+".substr( $scontrol, 2 );
    if ( strncmp( $scontrol, "-", 1 )== 0 ) 
        $scontrol = "+".substr( $scontrol, 1 );
    if (  $scontrol{0} == '+'  ) {
        for( $stop=$i=0; $i<strlen($scontrol) && !$stop; $i++ ) {
            if ( $scontrol{$i}==' ' || $scontrol{$i}==')' || $scontrol{$i}=='.' || $scontrol{$i}=='-' ) {
                $plus=1;
                $pays = substr( $scontrol, 1, $i-1 ).".";
                $scontrol = substr( $scontrol, $i );
                $stop=1;
                }
            }
        }
    else
    if ( $indicatif_pays ) {
        $plus=1;
        $pays = $indicatif_pays.".";
        }

    $scontrol = preg_replace("'\D*'si","",$scontrol );

    $rphone = ($plus ? "+":"").$pays.$scontrol;

    if ( control_telephone( $rphone ) )
        return $rphone;

    return "+1.1";
}

function control_telephone( $telephone )
{
    $telephone = str_replace( " ", "", $telephone );
    $telephone = str_replace( "\t", "", $telephone );

    if ( substr( $telephone, 0, 4 )=="+33." ) {
        if (mb_eregi( "^\+[0-9]{1,4}\.[1-9]{1}[0-9]{8}$", $telephone ))
            return ( 1 );
        else
            return ( 0 );
        }

    // controle la syntaxe ( +nnn.nnnnn )
    if (mb_eregi( "^\+[0-9]{1,4}\.[0-9 ]*$", $telephone )) {
        return ( 1 );
        }

    return ( 0 );
}

function map_paysid( $pays )
{

$mapp = array (
"AD" => 22, "AE" => 237, "AF" => 17, "AG" => 26, "AI" => 24, "AL" => 19,
"AM" => 28, "AN" => 165, "AO" => 23, "AQ" => 25, "AR" => 27, "AS" => 21,
"AT" => 31, "AU" => 30, "AW" => 29, "AX" => 18, "AZ" => 32, "BA" => 43,
"BB" => 36, "BD" => 35, "BE" => 11, "BF" => 50, "BG" => 49, "BH" => 34,
"BI" => 51, "BJ" => 39, "BM" => 40, "BN" => 48, "BO" => 42, "BR" => 46,
"BS" => 33, "BT" => 41, "BV" => 45, "BW" => 44, "BY" => 37, "BZ" => 38,
"CA" => 54, "CC" => 62, "CD" => 66, "CF" => 57, "CG" => 65, "CH" => 14,
"CI" => 69, "CK" => 67, "CL" => 59, "CM" => 53, "CN" => 60, "CO" => 63,
"CR" => 68, "CS" => 203, "CU" => 71, "CV" => 55, "CX" => 61, "CY" => 72,
"CZ" => 73, "DE" => 12, "DJ" => 75, "DK" => 74, "DM" => 76, "DO" => 77,
"DZ" => 20, "EC" => 78, "EE" => 83, "EG" => 79, "EH" => 248, "ER" => 82,
"ES" => 213, "ET" => 84, "FI" => 88, "FJ" => 87, "FK" => 85, "FM" => 154,
"FO" => 86, "FR" => 1, "GA" => 92, "GB" => 238, "GD" => 99, "GE" => 94,
"GF" => 89, "GG" => 254, "GH" => 95, "GI" => 96, "GL" => 98, "GM" => 93,
"GN" => 103, "GP" => 100, "GQ" => 81, "GR" => 97, "GS" => 212, "GT" => 102,
"GU" => 101, "GW" => 104, "GY" => 105, "HK" => 110, "HM" => 107, "HN" => 109,
"HR" => 70, "HT" => 106, "HU" => 111, "ID" => 114, "IE" => 117, "IL" => 119,
"IM" => 118, "IN" => 113, "IO" => 47, "IQ" => 116, "IR" => 115, "IS" => 112,
"IT" => 13, "JE" => 122, "JM" => 120, "JO" => 123, "JP" => 121, "KE" => 125,
"KG" => 130, "KH" => 52, "KI" => 126, "KM" => 64, "KN" => 194, "KP" => 127,
"KR" => 128, "KW" => 129, "KY" => 56, "KZ" => 124, "LA" => 131, "LB" => 133,
"LC" => 195, "LI" => 137, "LK" => 214, "LR" => 135, "LS" => 134, "LT" => 138,
"LU" => 139, "LV" => 132, "LY" => 136, "MA" => 159, "MC" => 156, "MD" => 155,
"ME" => 253, "MG" => 142, "MH" => 148, "MK" => 141, "ML" => 146, "MM" => 161,
"MN" => 157, "MO" => 140, "MP" => 173, "MQ" => 149, "MR" => 150, "MS" => 158,
"MT" => 147, "MU" => 151, "MV" => 145, "MW" => 143, "MX" => 153, "MY" => 144,
"MZ" => 160, "NA" => 162, "NC" => 166, "NE" => 169, "NF" => 172, "NG" => 170,
"NI" => 168, "NL" => 15, "NO" => 174, "NP" => 164, "NR" => 163, "NU" => 171,
"NZ" => 167, "OM" => 175, "PA" => 179, "PE" => 182, "PF" => 90, "PG" => 180,
"PH" => 183, "PK" => 176, "PL" => 185, "PM" => 196, "PN" => 184, "PR" => 187,
"PS" => 178, "PT" => 186, "PW" => 177, "PY" => 181, "QA" => 188, "RE" => 189,
"RO" => 190, "RS" => 252, "RU" => 191, "RW" => 192, "SA" => 201, "SB" => 209,
"SC" => 204, "SD" => 215, "SE" => 219, "SG" => 206, "SH" => 193, "SI" => 208,
"SJ" => 217, "SK" => 207, "SL" => 205, "SM" => 199, "SN" => 202, "SO" => 210,
"SR" => 216, "ST" => 200, "SV" => 80, "SY" => 220, "SZ" => 218, "TC" => 233,
"TD" => 58, "TF" => 91, "TG" => 226, "TH" => 224, "TJ" => 222, "TK" => 227,
"TL" => 225, "TM" => 232, "TN" => 230, "TO" => 228, "TR" => 231, "TT" => 229,
"TV" => 234, "TW" => 221, "TZ" => 223, "UA" => 236, "UG" => 235, "UM" => 239,
"US" => 7, "UY" => 240, "UZ" => 241, "VA" => 108, "VC" => 197, "VE" => 243,
"VG" => 245, "VI" => 246, "VN" => 244, "VU" => 242, "WF" => 247, "WS" => 198,
"YE" => 249, "YT" => 152, "ZA" => 211, "ZM" => 250, "ZW" => 251 );

	if ( isset( $mapp[$pays] ) )
		return( $mapp[$pays] );
	return( 1 );
}

function is_cee_country( $pays_id )
{
	$pcee = array ( 1, 11, 12, 13, 15, 31, 49, 72, 73, 74, 83, 88, 97, 111, 117, 132, 
	138, 139, 147, 185, 186, 190, 207, 208, 213, 219, 238,
	// Enregistrement de .EU possible pour certain DROM (Dpartement et rgion d'outre-mer)
        89 /*GUYANE FRANAISE*/, 100 /*GUADELOUPE*/, 149 /*MARTINIQUE*/, 189 /*RUNION*/,
	);

	if ( in_array( $pays_id, $pcee ) ) return(1);
	return(0);
}


function mkpasswd( $lng=12 )
{
    $tableau = array("a","b","c","d","e","f","g","h","j","k",'p','q','r','s','T','u','v','w','x','y','z',
        "A","D","E","F","G","H","J","K","L","M","N","P","Q","R","T","U","V","W","X","Y","Z",
        "1","2","3","4","6","7","8","9");

    shuffle($tableau);
    return ( substr( implode("",$tableau),0,$lng ) );
}

function valid_email( $email )
{
    if ( strlen($email) > 128 )
        return "";

    if (mb_eregi( "^[a-zA-Z0-9+._-]+@[a-zA-Z0-9.-]{2,}\.[a-zA-Z]{2,6}$", $email )) {
        $domain =  str_replace( "@", "", strrchr( $email, "@" ) );
        if ( checkdnsrr( $domain, "MX" ) ) return( $email );
        if ( checkdnsrr( $domain, "A" ) ) return( $email );
        }

    return "";
}
// algorithme de cle de Luhn 

function check_luhn( $ccNumber )
{

    $valid = 1;
    $total = 0;

    $numOfDigits = 0 - strlen($ccNumber);

    $i = -1;
    while ($i>=$numOfDigits) {
        if (($i % 2) == 0) {
            $double = 2*(substr($ccNumber, $i, 1));
            $total += substr($double,0,1);
            if (strlen($double > 1)) {
                $total += substr($double,1,1);
            }
        }
        else {
            $total += substr($ccNumber, $i, 1);
        }
        $i--;
    }

    if (($total % 10) != 0)
        $valid = 0;

    return( $valid );
}

// siren = 9 digits
// siret = 14 digits
function control_siret_siren( $relouformat )
{

    // vire tout ce qui n'est pas du numerique
    $scontrol = preg_replace("'\D*'si","",$relouformat );

    if ( $scontrol=="" || $scontrol== 0 )
        return(0);

    // siret ok ?
    if ( check_luhn( "".$scontrol ) == 1 )
        return (1);

    // control siret negatif, test juste le siren
    $scontrol = substr( $scontrol, 0, 9 );

    if ( check_luhn( "".$scontrol ) == 1 )
        return(1);

    // negatif, ce n'est pas un siret/siren
    return(0);
}

function valid_url( $url, $withnsentry=1 )
{
    if ( $url == "" ) 
        return ( "" );

    $purl = parse_url( $url );

    if ( $purl == FALSE || !isset( $purl['host'] ) )
        return ( "" );

    if ( valid_urlhostname( $purl['host'] )== "" )
        return ( "" );

    if ( $withnsentry==1 &&
         !checkdnsrr( $purl['host'], "A" ) &&
         !checkdnsrr( $purl['host'], "CNAME" ) &&
         !checkdnsrr( $purl['host'], "AAAA" ) &&
         valid_ipv4( $purl['host'] )=="" )
        return( "" );

    return( $url );
}

function valid_urlhostname( $host )
{
    if ( strstr( $host, "-." ) || strstr( $host, ".-" ) )
        return( "" );

    if ( $host{ strlen($host)-1 } == '.' || $host{ 0 } == '.' )
        return ( "" );
    if ( $host{ strlen($host)-1 } == '-' || $host{ 0 } == '-' )
        return ( "" );

    if (mb_eregi( "^[a-zA-Z0-9.-]+$", $host ))
        return( $host );

    return ( "" );
}

function valid_ipv4( $ipv4 )
{
    $elements = explode( ".", $ipv4 );
    if ( count( $elements ) != 4 ) return "";

    for ( $i=0; $i<4; $i++ ) {
        if ( !isset( $elements[$i] ) ) return "";
        if( !is_numeric( $elements[$i] ) ) return "" ;
        if ( $elements[$i] > 255 ) return "";
        if ( $elements[$i] < 0 ) return "";
        }

    return ( $ipv4 );
}

function valid_ipv6( $ipv6 )
{

    if (filter_var($ipv6,FILTER_VALIDATE_IP,FILTER_FLAG_IPV6)) {
        return( $ipv6 );
    };

    return( "" );
}

function array2asc( $ar )
{
    $tr1 = '';
    $tr2 = 'aaaaaaaaaaaaaacceeeeeeeeiiiiiiiinnoooooooooosuuuuuuuuy ';

    while ( list( $key, $val ) = each( $ar ) )
	if ( is_array( $val ) )
		$val = array2asc( $val );
	else
	        $ar[ $key ] = trim(strtr( utf8_decode($val), $tr1, $tr2 ) );

    return( $ar );
}

// return 0 si non, N>0 si match
function detectUTF8($string)
{
        return preg_match('%(?:
        [\xC2-\xDF][\x80-\xBF]        # non-overlong 2-byte
        |\xE0[\xA0-\xBF][\x80-\xBF]               # excluding overlongs
        |[\xE1-\xEC\xEE\xEF][\x80-\xBF]{2}      # straight 3-byte
        |\xED[\x80-\x9F][\x80-\xBF]               # excluding surrogates
        |\xF0[\x90-\xBF][\x80-\xBF]{2}    # planes 1-3
        |[\xF1-\xF3][\x80-\xBF]{3}                  # planes 4-15
        |\xF4[\x80-\x8F][\x80-\xBF]{2}    # plane 16
        )+%xs', $string);
}

function iso2asc( $ar )
{
    $tr1 = '';
    $tr2 = 'aaaaaaaaaaaaaacceeeeeeeeiiiiiiiinnoooooooooouuuuuuuuuy ';

    if ( is_string($ar) )
        return( trim(strtr( $ar, $tr1, $tr2 ) ) );

    if ( is_array($ar) )
        while ( list( $key, $val ) = each( $ar ) ) {
            while( detectUTF8( $val ) )
                $ar[$key] = $val = iconv("UTF-8", "ISO-8859-1//IGNORE", $val );
            $ar[ $key ] = trim(strtr( $val, $tr1, $tr2 ) );
            }

    return( $ar );
}

?>
