<?php

/*
 * rev 0.1 Oct,21 2017 [jcmichot]
 */

add_hook('AdminHomeWidgets', 1, function() {
    return new bookmynameModuleWidget();
});

class bookmynameModuleWidget extends \WHMCS\Module\AbstractWidget
{
    protected $title = 'Registrar Module (BookMyName)';
    protected $description = 'Registrar admin widget';
    protected $weight = 150;
    protected $columns = 1;
    protected $cache = false;
    protected $cacheExpiry = 120;
    protected $requiredPermission = '';

    public function getData()
    {
        // include only here, otherwise fatal redefine function in setup registrar
        require_once  $_SERVER['DOCUMENT_ROOT'] . '/includes/registrarfunctions.php';

        $params = getRegistrarConfigOptions('bookmyname');
        $ainfo = bookmyname_api_info($params);
        $apending = bookmyname_api_pending($params);
    
        $params['api_info'] = $ainfo[0]['retfields'];
        $params['api_pending'] = $apending['pending'];

        return array( $params );
    }

    public function generateOutput($data)
    {

    $message = '';
    if ( 0 /*debug*/ ) {
        ob_start();
        print_r( $data[0]['api_pending'] );
        $message = "<pre>".ob_get_contents()."</pre>";
        ob_end_clean();
        }

    $inforeg = sprintf("API ID %d (%s) %s\n",
        $data[0]['Username'], $data[0]['api_info']['dist_email'], $data[0]['api_info']['dist_name'] );
    if ( 'yes' == $data[0]['api_info']['reg_prepaye'] )
        $inforeg .= sprintf( ", <b>credit %.2f</b>", $data[0]['api_info']['credit_prepaye'] );

    $cpad='';
    foreach( $data[0]['api_pending'] as $pending ) {
        if ( !isset( $pending['domain'] ) ) continue;
        if ( '' == $pending['domain']     ) continue;
        
        $etat = htmlentities($pending['reply_msg']);
        if ( 'TransferRequest' == $pending['action'] && '' == $pending['reply_msg'] )
            $etat =  'status='.htmlentities( $pending['etat'] );

        $cpad .= "<div class=\"feed-element\">\n";
        $cpad .= "<div>\n";
        $cpad .= sprintf( "<small class=\"pull-right text-navy\">%s</small>\n", $pending['lastupdate'] );
        $cpad .= sprintf( "<strong>%s</strong>\n", $pending['domain'] );
        $cpad .= sprintf( "<div>%s <br> <a href=\"%s\" target=\"_blank\">%s</a></div>\n", $etat, $pending['url'], $pending['url'] );
        $cpad .= sprintf( "<small class=\"text-muted\">%s session_id %s</small>\n", $pending['action'], $pending['session_id'] );
        $cpad .= "<hr>";
        $cpad .= "</div>\n";
        $cpad .= "</div>\n\n";

        }

        return <<<EOF
<div class="widget-content-padded">
$inforeg<br>\nPending report<br><br>$cpad<br>\n$message
</div>
EOF;
    }
}

